
'//--------------------------------------------------------------------
'//
'// File: SSDLL.H
'//
'// Copyright (C) 1996 FarPoint Technologies.
'// All rights reserved.
'//
'//--------------------------------------------------------------------

'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=
'  SSDLL.INC Translated from SSDLL.H for use with PB/DLL 5.0
'  If any errors are found please contact:
'      James C. Fuller
'      jcfuller@jcfuller.com
'Update 02-16-1999 for use with PBDLL 6.0
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'05-05-2009
' I think I made a mistake by using Pb WORD for c WORD
' c WORD is 32 bit and Pb WORD is 16
' using this macro will leave the places I change visble
MACRO CWORD  = WORD
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=
'>>
'$INCLUDE    "WIN32API.INC"
'  #IF %DEF(%UNICODE)
'    $SS_CLASSNAME = "fpUSpread30"
'	 $SPV_CLASSNAME = "fpSpreadPreview"
'    $SS_DLLNAME = "SS3UD30.DLL"
'  #ELSE
    $SS_CLASSNAME = "fpSpread30"
    $SPV_CLASSNAME = "fpSpreadPreview"
    $SS_DLLNAME = "SPR32D30.DLL"
'  #ENDIF

'#ifndef SSDLL_H
'#define SSDLL_H
'$IF NOT %DEF(%SSDLL_H)
'  %SSDLL_H = 1
'$ENDIF
'#ifdef __cplusplus
'extern "C" {
'#endif
'
'#ifndef RC_INVOKED
'#pragma pack(1)
'#endif  /* RC_INVOKED */

'#IF 0

'/*
'//--------------------------------------------------------------------
'//
'//  Class name used in resource script or CreateWindow API call.
'//
'#if defined(WIN32) || defined(_WIN32)
'   #if defined(UNICODE) || defined(_UNICODE)
'      #define SS_CLASSNAME "va32Spread25u"
'      #define SS_DLLNAME "SS3UD25.DLL"
'   #else
'      #define SS_CLASSNAME "va32Spread25"
'      #define SS_DLLNAME "SPR32D30.DLL"
'   #endif
'#else
'   #define SS_CLASSNAME "va16Spread25"
'   #define SS_DLLNAME "SS16D25.DLL"
'#endif
'*/
'#ENDIF
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=
'

'//--------------------------------------------------------------------
'//
'// Spreadsheet window styles used in resource file or calls
'// to CreateWindow.
'//

%SSS_RESTRICTROWS       = &H001&
%SSS_RESTRICTCOLS       = &H002&
%SSS_PROTECT            = &H004&
%SSS_LOCKALL            = &H008&
%SSS_NORESIZE           = &H010&
%SSS_NOSELECTBLOCK      = &H020&
%SSS_NOGRIDLINES        = &H040&
%SSS_ALLOWUSERFORMULAS  = &H080&
%SSS_HIDECOLHEADERS     = &H100&
%SSS_HIDEROWHEADERS     = &H200&
%SSS_ALLOWCELLOVERFLOW  = &H400&
%SSS_SCROLLBAREXTMODE   = &H800&

'//--------------------------------------------------------------------
'//
'// Spreadsheet messages
'//

%SSM_DBLCLK             = &H0501
%SSM_EDITMODEON         = &H0502
%SSM_EDITMODEOFF        = &H0503
%SSM_CELLLOCKED         = &H0504
%SSM_ROWRESTRICTED      = &H0505
%SSM_COLRESTRICTED      = &H0506
%SSM_COLROWRESTRICTED   = &H0507
%SSM_DATACHANGE         = &H0508
%SSM_LEAVECELL          = &H0509
%SSM_CLICK              = &H050A
%SSM_KEYDOWN            = &H050B
%SSM_LEAVEROW           = &H050C
%SSM_RBUTTON            = &H050D
%SSM_ENTERROW           = &H050E
%SSM_COLWIDTHCHANGE     = &H050F
%SSM_ROWHEIGHTCHANGE    = &H0510
%SSM_DRAWITEM           = &H0511
%SSM_VQUERYDATA         = &H0512
%SSM_DRAGDROP           = &H0513
%SSM_VCLEARDATA         = &H0514
%SSM_KEYUP              = &H0515
%SSM_KEYPRESS           = &H0516
%SSM_COMBOSELCHANGE     = &H0517
%SSM_COMBODROPDOWN       = &H0518
%SSM_COMBOCLOSEUP        = &H0519
%SSM_TEXTTIPFETCH        = &H0520
%SSM_EDITCHANGE          = &H0521

'//--------------------------------------------------------------------
'//
'// Spreadsheet notification messages (part of WM_COMMAND message)
'//

%SSN_SETFOCUS          = 51
%SSN_KILLFOCUS         = 52
%SSN_INVALIDDATA       = 53
%SSN_BLOCKSELECTED     = 54
%SSN_BLOCKCHANGED      = 55
%SSN_USERFORMULA       = 56
%SSN_EXITNEXT          = 57
%SSN_EXITPREV          = 58
%SSN_BUTTONDOWN        = 59
%SSN_BUTTONUP          = 60
%SSN_TOPROWCHANGE      = 61
%SSN_LEFTCOLCHANGE     = 62
%SSN_TOPLEFTCHANGE     = 63
%SSN_BLOCKDESELECTED   = 64
%SSN_INVALIDPASTEDATA  = 65      '// Internal
%SSN_TYPINGPROHIBITED  = 66      '// Internal
%SSN_EDITMODEINS       = 67      '// Internal
%SSN_CHECKBOXTYPING    = 68      '// Internal

'//--------------------------------------------------------------------
'//
'//  Spreadsheet API decoration
'//


'/*
'#ifdef DLLENTRY
'#undef DLLENTRY
'#endif
'
'#if defined(WIN32) || defined(_WIN32)
'   #if defined(SS_DLL) || defined(SS_OCX) || defined(SS_VB)
'      %DLLENTRY __declspec(dllexport) __stdcall
'   #else
'      %DLLENTRY __stdcall
'   #endif
'#else
'   #if defined(SS_DLL) || defined(SS_OCX) || defined(SS_VB)
'      %DLLENTRY __export FAR PASCAL
'   #else
'      %DLLENTRY FAR PASCAL
'   #endif
'#endif
''//--------------------------------------------------------------------
'//
'//  Following definitions provide generic character and text types
'//  which can map to SBCS, DBCS, or Unicode.
'//

'#if !defined(_TCHAR_DEFINED)
'   %_TCHAR_DEFINED
'   #if defined(UNICODE) || defined(_UNICODE)
'      typedef wchar_t TCHAR;
'   #else
'      typedef char TCHAR;
'   #endif
'#endif

'//--------------------------------------------------------------------
'//
'//  Data types used by the spreadsheet.
'//

'typedef float FAR        *LPFLOAT;
'typedef short FAR        *LPSHORT;
'typedef BOOL FAR         *LPBOOL;
'typedef double FAR       *LPDOUBLE;
'typedef long double FAR  *LPLDOUBLE;
'typedef COLORREF FAR     *LPCOLORREF;
'typedef unsigned short    USHORT;
'typedef unsigned long     ULONG;

'#if defined(WIN32) || defined(_WIN32)
'   typedef char        *HPSTR;
'   typedef BYTE        *HPBYTE;
'   typedef short       *HPSHORT;
'   typedef VOID        *HPVOID;
'   typedef const VOID  *HPCVOID;
'   typedef TCHAR       *HPTSTR;
'   typedef const TCHAR *HPCTSTR;
'#else
'   typedef TCHAR FAR        *LPTSTR;
'   typedef const TCHAR FAR  *LPCTSTR;
'   typedef char huge        *HPSTR;
'   typedef BYTE huge        *HPBYTE;
'   typedef short huge       *HPSHORT;
'   typedef VOID huge        *HPVOID;
'   typedef const VOID huge  *HPCVOID;
'   typedef TCHAR huge       *HPTSTR;
'   typedef const TCHAR huge *HPCTSTR;
'#endif

'//--------------------------------------------------------------------
'//
'//  Spreadsheet specific data types.
'//

'typedef short             SS_FONTID;
'typedef short             SS_COLORID;
'
'#ifdef SS_USE16BITCOORDS
'typedef short SS_COORD;
'#else
'typedef long SS_COORD;
'#endif
'typedef SS_COORD FAR *LPSS_COORD;
'
'#if defined(WIN32) || defined(_WIN32)
'   typedef SS_COORD *HPSS_COORD;
'#else
'   typedef SS_COORD huge *HPSS_COORD;
'#endif
'*/


'//--------------------------------------------------------------------
'//
'//  The SS_CELLCOORD structure contains the coordinates for a cell.
'//


'typedef struct ss_cellcoord
'   {
'   SS_COORD Col;
'   SS_COORD Row;
'   } SS_CELLCOORD, FAR *LPSS_CELLCOORD;

TYPE ss_cellcoord
  Col       AS LONG
  Row       AS LONG
END TYPE
'//--------------------------------------------------------------------
'//
'//  The SS_CELLREF structure is used in the SS_VALUE structure when
'//  passing a cell reference to a custom function.
'//

'typedef struct ss_cellref
'   {
'   SS_COORD Col;
'   SS_COORD Row;
'   union
'     {
'     HWND hwndSS;
'     long lInfo;  '// internal use only
'     }u;
'   } SS_CELLREF, FAR* LPSS_CELLREF;
 UNION ssu
   hWndSS       AS DWORD
   lInfo        AS LONG
 END UNION
 TYPE ss_cellref
   Col      AS LONG
   Row      AS LONG
   u        AS ssu
 END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_COORDRANGE structure contains the coordinates for a
'//  range of cells.
'//

'typedef struct ss_coordrange
'   {
'   SS_COORD Coord1;
'   SS_COORD Coord2;
'   } SS_COORDRANGE, FAR *LPSS_COORDRANGE;

TYPE ss_coordrange
  Coord1    AS LONG
  Coord2    AS LONG
END TYPE

'//--------------------------------------------------------------------
'//
'//  The SS_DATE structure represents a date.
'//

'typedef struct tagSS_DATE
'   {
'   int nDay;      '// Day of the Month  1..31
'   int nMonth;    '// Month of the Year 1..12
'   int nYear;     '// Year
'   } SS_DATE, FAR *LPSS_DATE;

TYPE tagSS_DATE
  nDay      AS LONG
  nMonth    AS LONG
  nYear     AS LONG
END TYPE
'//--------------------------------------------------------------------
'//
'//  The SS_DATEFORMAT structure describes the format used to display
'//  a date.
'//

'typedef struct tagSS_DATEFORMAT
'   {
'   BOOL   bCentury;
'   TCHAR  cSeparator;
'   int    nFormat;
'   BOOL   bSpin;
'   } SS_DATEFORMAT, FAR *LPSS_DATEFORMAT;
'TYPE tagSS_DATEFORMAT
'  bCentury      AS LONG
'  cSeparator    AS BYTE
'  nFormat       AS LONG
'  bSpin         AS LONG
'END TYPE

TYPE tagSS_DATEFORMAT
  bCentury      AS LONG
  cSeperator    AS BYTE
  nFormat       AS LONG
  bSpin         AS LONG
END TYPE


%IDF_DDMONYY   = 100
%IDF_DDMMYY    = 101
%IDF_MMDDYY    = 102
%IDF_YYMMDD    = 103
'//- New date formats added in the JPN version. (Masanori Iwasa)
%IDF_YYMM       = 104
%IDF_MMDD       = 105
%IDF_NYYMMDD    = 106
%IDF_NNYYMMDD   = 107
%IDF_NNNNYYMMDD = 108


'//--------------------------------------------------------------------
'//
'//  The SS_DRAWITEMSTRUCT structure contains information needed by
'//  the application to paint a owner drawn cell.  The structure is
'//  sent to the application in a SSM_DRAWITEM message.
'//

'typedef struct ss_drawitemstruct
'   {
'   WORD     CtlID;   '// ID of spreadsheet control
'   SS_COORD Col;     '// Column of cell to be drawn
'   SS_COORD Row;     '// Row of cell to be drawn
'   HWND     hWnd;    '// Spreadsheet window handle
'   HDC      hDC;     '// Spreadsheet device context to be used
'   RECT     Rect;    '// Rectangle of cell.  All drawing must be
'                     '//   be done within this rectangle.
'   long     lStyle;  '// User defined style
'   LPCTSTR  lpData;  '// Cell data
'   } SS_DRAWITEMSTRUCT, FAR *LPSS_DRAWITEMSTRUCT;

TYPE ss_drawitemstruct
  CtlID         AS CWORD
  Col           AS LONG
  Row           AS LONG
  hWnd          AS DWORD
  hDc           AS DWORD
  Rect          AS RECT
  lStyle        AS LONG
  lpData        AS ASCIIZ PTR
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_EDITMODEOFF structure is used the SSM_EDITMODEOFF message.
'//

'typedef struct ss_editmodeoff
'   {
'   SS_COORD Col;
'   SS_COORD Row;
'   BOOL     fChangeMade;
'   } SS_EDITMODEOFF, FAR *LPSS_EDITMODEOFF;

TYPE ss_editmodeoff
  Col           AS LONG
  Row           AS LONG
  fChangeMade   AS LONG
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_ENTERROW structure is used in the SSM_ENTERROW message.
'//

'typedef struct ss_enterrow
'   {
'   SS_COORD Row;
'   BOOL     fNewRow;
'   } SS_ENTERROW, FAR *LPSS_ENTERROW;

TYPE ss_enterrow
  Row       AS LONG
  fNewRow   AS LONG
END TYPE

'//--------------------------------------------------------------------
'//
'//  The SS_FLOATFORMAT structure describes the format used to
'//  display a floating point number.
'//

'typedef struct tagSS_FLOATFORMAT
'   {
'   TCHAR  cCurrencySign;
'   TCHAR  cDecimalSign;
'   TCHAR  cSeparator;
'   } SS_FLOATFORMAT, FAR *LPSS_FLOATFORMAT;

TYPE tagSS_FLOATFORMAT
  cCurrencySign     AS BYTE
  cDecimalSign      AS BYTE
  cSeparator        AS BYTE
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_LEAVECELL structure is used in the SSM_LEAVECELL message.
'//

'typedef struct ss_leavecell
'   {
'   SS_COORD ColCurrent;
'   SS_COORD RowCurrent;
'   SS_COORD ColNew;
'   SS_COORD RowNew;
'   } SS_LEAVECELL, FAR *LPSS_LEAVECELL;

TYPE ss_leavecell
  ColCurrent    AS LONG
  RowCurrent    AS LONG
  ColNew        AS LONG
  RowNew        AS LONG
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_LEAVEROW structure is used in the SSM_LEAVEROW message.
'//

'typedef struct ss_leaverow
'   {
'   SS_COORD RowCurrent;        '// Current selected row
'   SS_COORD RowNew;            '// New row being entered
'   BOOL     fRowEdited;        '// The user entered edit mode within
'                               '//   the current row
'   BOOL     fRowChangeMade;    '// The user made a change to the
'                               '//   current row
'   BOOL     fRowNewBeyondLastDataRow; '// The new row the user is clicking
'                               '//   into is beyond the row below
'                               '//   the last row containing data.  The
'                               '//   purpose of this flag is so the
'                               '//   application can limit the user to
'                               '//   entering data one line at a time
'                               '//   and not skipping rows.
'   BOOL     fAllCellsHaveData; '// All cells within the current row
'                               '//   have data
'   BOOL     fAddRow;           '// The current row that was just edited
'                               '//   should be treated as a new row.
'   BOOL     fCancel;           '// If the application chooses to
'                               '//   prevent the user from entering
'                               '//   the new row, this value should be
'                               '//   set to TRUE upon exiting the
'                               '//   SSM_LEAVEROW message.
'   } SS_LEAVEROW, FAR *LPSS_LEAVEROW;

TYPE ss_leaverow
  RowCurrent                AS LONG
  RowNew                    AS LONG
  fRowEdited                AS LONG
  fRowChangeMade            AS LONG
  fRowNewBeyondLastDataRow  AS LONG
  fAllCellsHaveData         AS LONG
  fAddRow                   AS LONG
  fCancel                   AS LONG
END TYPE
'------------------------------------------------------------------------------
'SPREAD30
'//--------------------------------------------------------------------
'//
'//  The SS_COMBOCLOSEUP structure is used the SSM_COMBOCLOSEUP message.
'//
'
'typedef struct ss_ComboCloseUp
'   {
'   SS_COORD Col;
'   SS_COORD Row;
'   short    dSelChange;
'   } SS_COMBOCLOSEUP, FAR *LPSS_COMBOCLOSEUP;
'
'//--------------------------------------------------------------------
TYPE ss_ComboCloseUp
	Col 			AS LONG
	Row 			AS LONG
	dSelChange	AS INTEGER
END TYPE



'//--------------------------------------------------------------------
'//
'//  The SS_PRINT format structure contains information passed to
'//  the SSPrint() fucntion.
'//

'typedef struct ss_printformat
'   {
'   BOOL     fDrawBorder;
'   BOOL     fDrawShadows;
'   BOOL     fDrawColors;
'   BOOL     fShowGrid;
'   BOOL     fShowColHeaders;
'   BOOL     fShowRowHeaders;
'   BOOL     fUseDataMax;
'   short    dPrintType;
'   SS_COORD x1CellRange;
'   SS_COORD y1CellRange;
'   SS_COORD x2CellRange;
'   SS_COORD y2CellRange;
'   short    nPageStart;
'   short    nPageEnd;
'   float    fMarginLeft;
'   float    fMarginTop;
'   float    fMarginRight;
'   float    fMarginBottom;
'   HDC      hDCPrinter;
'   WORD     wOrientation;
'   char     Filler[18];
'   } SS_PRINTFORMAT, FAR *LPSS_PRINTFORMAT;

TYPE ss_printformat
  fDrawBorder       AS LONG
  fDrawShadows      AS LONG
  fDrawColors       AS LONG
  fShowGrid         AS LONG
  fShowColHeaders   AS LONG
  fShowRowHeaders   AS LONG
  fUseDataMax       AS LONG
  dPrintType        AS INTEGER
  x1CellRange       AS LONG
  y1CellRange       AS LONG
  x2CellRange       AS LONG
  y2CellRange       AS LONG
  nPageStart        AS INTEGER
  nPageEnd          AS INTEGER
  fMarginLeft       AS SINGLE
  fMarginTop        AS SINGLE
  fMarginRight      AS SINGLE
  fMarginBottom     AS SINGLE
  hDCPrinter        AS DWORD
  wOrientation      AS CWORD
  fSmartPrint		AS BYTE
  Filler            AS ASCIIZ *18
END TYPE

%SS_PRINTTYPE_CURRENTPAGE = &H01
%SS_PRINTTYPE_CELLRANGE   = &H02
%SS_PRINTTYPE_PAGERANGE   = &H04
%SS_PRINTTYPE_LEFTTORIGHT = &H08
%SS_PRINTTYPE_DOWNTHENOVER = &H10

%SS_PRINTORIENT_DEFAULT   =0
%SS_PRINTORIENT_PORTRAIT  =1
%SS_PRINTORIENT_LANDSCAPE =2

%SS_PRINTCMD_HEADERLEN   =0
%SS_PRINTCMD_FOOTERLEN   =1
%SS_PRINTCMD_PRINTHEADER =2
%SS_PRINTCMD_PRINTFOOTER =3


'typedef struct ss_printinfo
'   {
'   BOOL fIsPreview;
'   HDC  hDCPrinter;
'   RECT RectPreview;
'   RECT RectPrinter;
'   } SS_PRINTINFO, FAR *LPSS_PRINTINFO;

TYPE ss_printinfo
    flsPreview  	AS LONG
	 hdcPrinter		AS LONG
	 RectPreview	AS RECT
	 RectPrinter	AS RECT
END TYPE

'typedef short (CALLBACK* SS_PRINTFUNC)(HDC hDC, short dCommand,
'                                       short nPageNum, LONG lAppData);

'//--------------------------------------------------------------------
'//
'//  The SS_RANGEREF structure is used in the SS_VALUE structure when
'//  passing a cell range reference to a custom function.
'//

'typedef struct ss_rangeref
'   {
'   SS_COORD Col1;
'   SS_COORD Row1;
'   SS_COORD Col2;
'   SS_COORD Row2;
'   union
'     {
'     HWND hwndSS;
'     long lInfo;  '// internal use only
'     }u;
'   } SS_RANGEREF, FAR* LPSS_RANGEREF;

TYPE ss_rangeref
  Col1          AS LONG
  Row1          AS LONG
  Col2          AS LONG
  Row2          AS LONG
  u             AS ssu
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_RBUTTON structure is used in the SSM_RBUTTON message.
'//

'typedef struct ss_rbutton
'   {
'   SS_COORD Col;          '// Column that was clicked on
'   SS_COORD Row;          '// Row that was clicked on
'   short    xPos;         '// Mouse x coordinate
'   short    yPos;         '// Mouse y coordinate
'   short    RButtonType;  '// Button Type. May be one of the following:
'                          '//     RBUTTONTYPE_DOWN
'                          '//     RBUTTONTYPE_UP
'                          '//     RBUTTONTYPE_DBLCLK
'   } SS_RBUTTON, FAR *LPSS_RBUTTON;


TYPE ss_rbutton
  Col           AS LONG
  Row           AS LONG
  xPos          AS INTEGER
  yPos          AS INTEGER
  RButtonType   AS INTEGER
END TYPE

%RBUTTONTYPE_DOWN   =0
%RBUTTONTYPE_UP     =1
%RBUTTONTYPE_DBLCLK =2



'//--------------------------------------------------------------------
'//
'//  The SS_SELBLOCK structure contains the coordinates for a block
'//  of cells.
'//

'typedef struct ss_selblock
'   {
'   SS_CELLCOORD UL;  '// Upper left cell coordinate
'   SS_CELLCOORD LR;  '// Lower right cell coordinate
'   } SS_SELBLOCK, FAR *LPSS_SELBLOCK;

TYPE ss_selblock
  UL        AS SS_CELLCOORD
  LR        AS SS_CELLCOORD
END TYPE
'//--------------------------------------------------------------------
'//
'//  The SS_SORT structure contains information passed to the SSSort()
'//  function.
'//


'typedef struct ss_sort
'   {
'   WORD     wSortBy;        '// Sort by rows or columns. Use
'                            '// one of the following:
'                            '//    SS_SORT_ROW
'                            '//    SS_SORT_COL
'   SS_COORD Key1Reference;  '// Column or row of first key.  Key1
'                            '// must be specified.
'   WORD     wKey1Order;     '// The sort order of Key1.  One of the
'                            '// following may be used:
'                            '//    SS_SORT_ASCENDING
'                            '//    SS_SORT_DESCENDING
'   SS_COORD Key2Reference;  '// Column or row of second key.  Key2
'                            '// must be -1 if only 1 key is desired
'   WORD     wKey2Order;     '// The sort order of Key2.  One of the
'                            '// following may be used:
'                            '//    SS_SORT_NONE - No Key2
'                            '//    SS_SORT_ASCENDING
'                            '//    SS_SORT_DESCENDING
'   SS_COORD Key3Reference;  '// Column or row of second key.  Key3
'                            '// must be -1 if 2 keys are desired.
'   WORD     wKey3Order;     '// The sort order of Key3.  One of the
'                            '// following may be used:
'                            '//    SS_SORT_NONE - No Key3
'                            '//    SS_SORT_ASCENDING
'                            '//    SS_SORT_DESCENDING
'   } SS_SORT, FAR *LPSS_SORT;

TYPE ss_sort
    wSortBy         AS CWORD
    Key1Reference   AS LONG
    wKey1Order      AS CWORD
    Key2Reference   AS LONG
    wKey2Order      AS CWORD
    Key3Reference   AS LONG
    wKey3Order      AS CWORD
END TYPE


%SS_SORT_ROW           = 0
%SS_SORT_COL           = 1

%SS_SORT_NONE          = 0
%SS_SORT_ASCENDING     = 1
%SS_SORT_DESCENDING    = 2

'typedef int (FAR PASCAL *SS_SORTCOMPARE)(HPVOID, HPVOID, long);


'//--------------------------------------------------------------------
'//
'//  The SS_TIME structure represents a time.
'//

'typedef struct tagSS_TIME
'   {
'   int nHour;    '// Hour 0..23
'   int nMinute;  '// Minutes 0..59
'   int nSecond;  '// Seconds 0..59
'   } SS_TIME, FAR *LPSS_TIME;

TYPE tagSS_TIME
  nHour     AS LONG
  nMinute   AS LONG
  nSecond   AS LONG
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_TIMEFORMAT structure describes the format used to display
'//  a time.
'//

'typedef struct tagSS_TIMEFORMAT
'   {
'   BOOL   b24Hour;
'   BOOL   bSeconds;
'   TCHAR  cSeparator;
'   BOOL   bSpin;
'   } SS_TIMEFORMAT, FAR *LPSS_TIMEFORMAT;

TYPE tagSS_TIMEFORMAT
  b24Hour       AS LONG
  bSeconds      AS LONG
  cSeperator    AS BYTE
  bSpin         AS LONG
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_VALUE structure is used in the evaluation of custom
'//  fucntions.
'//

'typedef struct ss_value
'   {
'   BYTE Status;
'   BYTE Type;
'   union
'      {
'      HGLOBAL     hValStr;
'      long        ValLong;
'      double      ValDouble;
'      SS_CELLREF  ValCell;
'      SS_RANGEREF ValRange;
'      } Val;
'   } SS_VALUE, FAR *LPSS_VALUE;

UNION uVal
  hValStr       AS DWORD
  ValLong       AS LONG
  ValDouble     AS DOUBLE
  ValCell       AS SS_CELLREF
  ValRange      AS SS_RANGEREF
END UNION
TYPE ss_value
  STATUS        AS BYTE
  nType         AS BYTE
  uVal          AS UVAL

END TYPE


'// Note: SS_VALUE_STATUSCLEAR and
'//       SS_VALUE_STATUS_NONE are
'//       for internal use only.

%SS_VALUE_STATUS_OK     =0
%SS_VALUE_STATUS_ERROR  =1
%SS_VALUE_STATUS_EMPTY  =2
%SS_VALUE_STATUS_CLEAR  =3
%SS_VALUE_STATUS_NONE   =4

%SS_VALUE_TYPE_LONG     =0
%SS_VALUE_TYPE_DOUBLE   =1
%SS_VALUE_TYPE_STR      =2
%SS_VALUE_TYPE_CELL     =3
%SS_VALUE_TYPE_RANGE    =4




'typedef FARPROC SS_CALCFUNC;

'//--------------------------------------------------------------------
'//
'//  The SS_VCLEARDATA structure is used in the SSM_VCLEARDATA message.
'//

'typedef struct ss_vcleardata
'   {
'   SS_COORD Row;               '// Top row of buffer being cleared
'   SS_COORD RowsBeingCleared;  '// The number of rows being cleared
'   } SS_VCLEARDATA, FAR *LPSS_VCLEARDATA;

TYPE ss_vcleardata
  Row               AS LONG
  RowsBeingCleared  AS LONG
END TYPE


'//--------------------------------------------------------------------
'//
'//  The SS_VQUERYDATA structure is used in the SSM_VQUERYDATA message.
'//

'typedef struct ss_vquerydata
'   {
'   SS_COORD Row;         '// Virtual top row to begin
'                         '//   assignment of data
'   SS_COORD RowsNeeded;  '// The number of rows requested
'   SS_COORD RowsLoaded;  '// The application should set the
'                         '//   number of rows actually loaded
'                         '//   before returning
'   WORD     wDirection;  '// Direction to retrieve data
'                         '//   SS_VDOWN
'                         '//   SS_VUP
'                         '//   SS_VTOP
'                         '//   SS_VBOTTOM
'                         '//   SS_VREFRESH
'   BOOL     fAtTop;      '// The application should set this
'                         '//   flag to TRUE if the top of the
'                         '//   data has been reached
'   BOOL     fAtBottom;   '// The application should set this
'                         '//   flag to TRUE if the bottom of the
'                         '//   data has been reached
'   } SS_VQUERYDATA, FAR *LPSS_VQUERYDATA;

TYPE ss_vquerydata
  Row           AS LONG
  RowsNeeded    AS LONG
  RowsLoaded    AS LONG
  wDirection    AS CWORD
  fAtTop        AS LONG
  fAtBottom     AS LONG
END TYPE

%SS_VDOWN    =1
%SS_VUP      =2
%SS_VTOP     =3
%SS_VBOTTOM  =4
%SS_VREFRESH =5


'//--------------------------------------------------------------------
'//
'//  The SUPERBTNCOLOR structure describes the colors used to paint
'//  a button.
'//

'typedef struct superbtncolor
'   {
'   COLORREF Color;
'   COLORREF ColorBorder;
'   COLORREF ColorShadow;
'   COLORREF ColorHighlight;
'   COLORREF ColorText;
'   } SUPERBTNCOLOR, FAR *LPSUPERBTNCOLOR;

TYPE superbtncolor
  COLOR             AS LONG
  ColorBorder       AS LONG
  ColorShadow       AS LONG
  ColorHighlight    AS LONG
  ColorText         AS LONG
END TYPE

'//--------------------------------------------------------------------
'//
'//  The SS_CELLTYPE structure contains information for displaying
'//  and editing a cell.
'//

'typedef ULONG TBGLOBALHANDLE, FAR *LPTBGLOBALHANDLE;

'typedef struct ss_celltype
'   {
'   BYTE  Type;
'   short ControlID;
'   long  Style;
'   union
'      {
'      struct
'     {
'     short  ChrSet;
'     short  Len;
'     short  ChrCase;
'     double dfWidth;
'     short  nRowCnt;
'     } Edit;
'      struct
'     {
'     long  Min;
'     long  Max;
'     BOOL  fSpinWrap;
'     long  lSpinInc;
'     } Integer;
'      struct
'     {
'     short       Left;
'     short       Right;
'     double      Min;
'     double      Max;
'     BOOL        fSetFormat;
'     SS_FLOATFORMAT Format;
'     } Float;
'      struct
'     {
'     short          dItemCnt;
'     TBGLOBALHANDLE hItems;
'     } ComboBox;
'      struct
'     {
'     BOOL       SetFormat;
'     BOOL       SetRange;
'     SS_TIMEFORMAT Format;
'     SS_TIME       Min;
'     SS_TIME       Max;
'     } Time;
'      struct
'     {
'     BOOL       SetFormat;
'     BOOL       SetRange;
'     SS_DATEFORMAT Format;
'     SS_DATE    Min;
'     SS_DATE    Max;
'     } Date;
'      struct
'     {
'     TBGLOBALHANDLE hMask;
'     } Pic;
'      struct
'     {
'     TBGLOBALHANDLE hPictName;
'     HPALETTE       hPal;
'#ifdef SS_VB
'     HANDLE         hPic;
'#endif
'#ifdef SS_OCX
'   LPVOID         lpPict;
'#endif
'     BOOL           fDeleteHandle;
'     } ViewPict;
'      struct
'     {
'     HGLOBAL  hText;
'     HGLOBAL  hPictName;
'     HGLOBAL  hPictDownName;
'     short    nPictureType;
'     short    nPictureDownType;
'     BYTE     ButtonType;
'     BYTE     ShadowSize;
'     BYTE     fDelHandle;
'     BYTE     fDelDownHandle;
'     SUPERBTNCOLOR Color;
'#ifdef SS_VB
'     HANDLE         hPic;
'     HANDLE         hPicDown;
'#endif
'#ifdef SS_OCX
'   LPVOID         lpPict;
'   LPVOID         lpPictDown;
'#endif
'     } Button;
'      struct
'     {
'     HGLOBAL        hText;
'     TBGLOBALHANDLE hPictUpName;
'     TBGLOBALHANDLE hPictDownName;
'     TBGLOBALHANDLE hPictFocusUpName;
'     TBGLOBALHANDLE hPictFocusDownName;
'     TBGLOBALHANDLE hPictGrayName;
'     TBGLOBALHANDLE hPictFocusGrayName;
'     BYTE           bPictUpType;
'     BYTE           bPictDownType;
'     BYTE           bPictFocusUpType;
'     BYTE           bPictFocusDownType;
'     BYTE           bPictGrayType;
'     BYTE           bPictFocusGrayType;
'     BYTE           fDelUpHandle;
'     BYTE           fDelDownHandle;
'     BYTE           fDelFocusUpHandle;
'     BYTE           fDelFocusDownHandle;
'     BYTE           fDelGrayHandle;
'     BYTE           fDelFocusGrayHandle;
'#ifdef SS_VB
'     HANDLE         hPicUp;
'     HANDLE         hPicDown;
'     HANDLE         hPicFocusUp;
'     HANDLE         hPicFocusDown;
'     HANDLE         hPicGray;
'     HANDLE         hPicFocusGray;
'#endif
'#ifdef SS_OCX
'   LPVOID         lpPictUp;
'   LPVOID         lpPictDown;
'   LPVOID         lpPictFocusUp;
'   LPVOID         lpPictFocusDown;
'   LPVOID         lpPictGray;
'   LPVOID         lpPictFocusGray;
'#endif
'     } CheckBox;
'
'      BYTE Dummy[34];
'      /*
'      char Dummy[45];
'      */
'      } Spec;
'   } SS_CELLTYPE, FAR *LPSS_CELLTYPE;
'
TYPE TEdit
  ChrSet        AS INTEGER
  xLen          AS INTEGER
  ChrCase       AS INTEGER
  dfWidth       AS DOUBLE
  nRowCnt       AS INTEGER
END TYPE
TYPE TInteger
  xMin      AS LONG
  xMax      AS LONG
  fSpinWrap AS LONG
  lSpinInc  AS LONG
END TYPE
TYPE TFloat
  xLeft         AS INTEGER
  xRight         AS INTEGER
  xMin          AS DOUBLE
  xMax          AS DOUBLE
  fSetFormat    AS LONG
  Format        AS tagSS_FLOATFORMAT
END TYPE
TYPE TComboBox
  dItemCnt      AS INTEGER
  hItems        AS LONG
END TYPE
TYPE TTime
  SetFormat     AS tagSS_TIMEFORMAT
  xMin          AS tagSS_TIME
  xMax          AS tagSS_TIME
END TYPE
TYPE TDate
  SetFormat     AS LONG
  SetRange      AS LONG
  Format        AS tagSS_DATEFORMAT
  xMin          AS tagSS_DATE
  xMax          AS tagSS_DATE
END TYPE
TYPE TPic
  hMask         AS DWORD
END TYPE
TYPE TViewPic
  hPictName     AS DWORD
  hPal          AS DWORD
  fDeleteHandle AS LONG
END TYPE
TYPE TButton
  hText             AS DWORD
  hPictName         AS DWORD
  hPictDownName     AS DWORD
  nPictureType      AS INTEGER
  nPictureDownType  AS INTEGER
  ButtonType        AS BYTE
  ShadowSize        AS BYTE
  fDelHandle        AS BYTE
  fDelDownHandle    AS BYTE
  COLOR             AS SUPERBTNCOLOR
END TYPE
TYPE TCheckBox
  hText                 AS DWORD
  hPictUpName           AS DWORD
  hPictDownName         AS DWORD
  hPictFocusUpName      AS DWORD
  hPictFocusDownName    AS DWORD
  hPictGrayName         AS DWORD
  hPictFocusGrayName    AS DWORD
  bPictUpType           AS BYTE
  bPictDownType         AS BYTE
  bPictFocusUpType      AS BYTE
  bPictFocusDownType    AS BYTE
  bPictGrayType         AS BYTE
  bPictFocusGrayType    AS BYTE
  fDelUpHandle          AS BYTE
  fDelDownHandle        AS BYTE
  fDelFocusUpHandle     AS BYTE
  fDelFocusDownHandle   AS BYTE
  fDelGrayHandle        AS BYTE
  fDelFocusGrayHandle   AS BYTE
END TYPE
UNION   uSpec
  tEdit         AS TEDIT
  tInteger      AS TINTEGER
  tFloat        AS TFLOAT
  tComboBox     AS TCOMBOBOX
  tTime         AS TTIME
  tDate         AS TDATE
  tPic          AS TPIC
  tViewPic      AS TVIEWPIC
  tButton       AS TBUTTON
  tCheckBox     AS TCHECKBOX
END UNION
TYPE ss_celltype
  xType                 AS BYTE
  ControlID             AS INTEGER
  Style                 AS LONG
  USPEC
  Dummy(34)             AS BYTE
END TYPE


%SS_TYPE_DATE          = 1
%SS_TYPE_EDIT          = 2
%SS_TYPE_PIC           = 3
%SS_TYPE_FLOAT         = 4
%SS_TYPE_INTEGER       = 5
%SS_TYPE_STATICTEXT    = 6
%SS_TYPE_TIME          = 7
%SS_TYPE_PICTURE       = 8
%SS_TYPE_BUTTON        = 10
%SS_TYPE_COMBOBOX      = 11
%SS_TYPE_CHECKBOX      = 12
%SS_TYPE_OWNERDRAW     = 13

'//--------------------------------------------------------------------
'//
'//  The SS_DRAGDROP structure is used in the SSM_DRAGDROP message.
'//

'typedef struct ss_dragdrop
'   {
'   SS_SELBLOCK BlockPrev;  '// Previous block
'   SS_SELBLOCK BlockNew;   '// New block being draged to
'   BOOL        fDataBeingOverwritten;  '// TRUE if data is being overwritten
'   BOOL        fCopy;      '// TRUE if the data is being copied.
'                           '//   FALSE if the data is being moved.
'   BOOL        fDataOnly;  '// The application should return TRUE
'                           '//   if only the data should be copied,
'                           '//   otherwise all formatting attributes
'                           '//   will be transfered.
'   BOOL        fCancel;    '// The application should return TRUE
'                           '//   if the drag/drop operation should
'                           '//   be canceled.
'   } SS_DRAGDROP, FAR *LPSS_DRAGDROP;

TYPE ss_dragdrop
  BlockPrev             AS SS_SELBLOCK
  BlockNew              AS SS_SELBLOCK
  fDataBeingOverwritten AS LONG
  fCopy                 AS LONG
  fDataOnly             AS LONG
  fCancel               AS LONG
END TYPE

'//--------------------------------------------------------------------
'//
'//  Internal constants
'//

%SS_FONT_NONE          = -1

%SS_NUM_PLUSMINUS      = 0
%SS_NUM_PLUS           = 1

%SS_GWL_USERDATA       = 4

%SS_ROWHEIGHT_DEFAULT  = 0
%SS_COLWIDTH_DEFAULT   = 0

%SS_SCROLLAREA_ALL     = 0
%SS_SCROLLAREA_COLS    = 1
%SS_SCROLLAREA_ROWS    = 2
%SS_SCROLLAREA_CELLS   = 3



'//--------------------------------------------------------------------
'//
'//  Spreadsheet function prototypes
'//
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSAddCustomFunction(HWND hWnd, LPCTSTR FunctionName,
'                                  short ParameterCnt, FARPROC lpfnFunctionProc);

DECLARE _
  FUNCTION _
    SSAddCustomFunction LIB "SPR32D30.DLL" ALIAS "SSAddCustomFunction" ( _
      BYVAL hWnd                AS DWORD,_
            lpszFuncName        AS ASCIIZ,_
      BYVAL ParameterCnt        AS INTEGER,_
      BYVAL lpfnFuncProc        AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSAddCustomFunctionExt(HWND hWnd, LPCTSTR lpszFuncName,
'                                     short nMinParamCnt, short nMaxParamCnt,
'                                     FARPROC lpfnFuncProc, long lFlags);
DECLARE _
  FUNCTION _
    SSAddCustomFunctionExt LIB "SPR32D30.DLL" ALIAS "SSAddCustomFunctionExt" ( _
      BYVAL hWnd                AS DWORD,_
            lpszFuncName        AS ASCIIZ,_
      BYVAL nMinParamCnt        AS INTEGER,_
      BYVAL nMaxParamCnt        AS INTEGER,_
      BYVAL lpfnFuncProc        AS DWORD,_
      BYVAL lFlags              AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSAddMultiSelBlocks(HWND hWnd, LPSS_SELBLOCK lpSelBlock);

DECLARE _
  FUNCTION _
    SSAddMultiSelBlocks LIB "SPR32D30.DLL" ALIAS "SSAddMultiSelBlocks" ( _
      BYVAL hWnd            AS DWORD,_
            lpSelBlock      AS SS_SELBLOCK _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSBuildDependencies(HWND hWnd);

DECLARE _
  FUNCTION _
    SSBuildDependencies LIB "SPR32D30.DLL" ALIAS "SSBuildDependencies" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClear(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSClear LIB "SPR32D30.DLL" ALIAS "SSClear" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClearData(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSClearData LIB "SPR32D30.DLL" ALIAS "SSClearData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClearDataRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                               SS_COORD Col2, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSClearDataRange LIB "SPR32D30.DLL" ALIAS "SSClearDataRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClearRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           SS_COORD Col2, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSClearRange LIB "SPR32D30.DLL" ALIAS "SSClearRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClipboardCopy(HWND hWnd);

DECLARE _
  FUNCTION _
    SSClipboardCopy LIB "SPR32D30.DLL" ALIAS "SSClipboardCopy" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClipboardCut(HWND hWnd);

DECLARE _
  FUNCTION _
    SSClipboardCut LIB "SPR32D30.DLL" ALIAS "SSClipboardCut" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClipboardPaste(HWND hWnd);

DECLARE _
  FUNCTION _
    SSClipboardPaste LIB "SPR32D30.DLL" ALIAS "SSClipboardPaste" ( _
      BYVAL hWnd            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------


'BOOL DLLENTRY SSClipIn(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                       SS_COORD Col2, SS_COORD Row2,
'                       LPCTSTR Buffer, long BufferLen);

DECLARE _
  FUNCTION _
    SSClipIn LIB "SPR32D30.DLL" ALIAS "SSClipIn" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG, _
      BYVAL Row2            AS LONG, _
            lpszBuffer      AS ASCIIZ,_
      BYVAL BufferLen       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'HGLOBAL DLLENTRY SSClipOut(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           SS_COORD Col2, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSClipOut LIB "SPR32D30.DLL" ALIAS "SSClipOut" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG _
   ) AS DWORD
'---------------------------------------------------------------------------

'BOOL DLLENTRY SSClipValueIn(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                            SS_COORD Col2, SS_COORD Row2,
'                            LPCTSTR Buffer, long BufferLen);

DECLARE _
  FUNCTION _
    SSClipValueIn LIB "SPR32D30.DLL" ALIAS "SSClipValueIn" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
            lpszBuffer      AS ASCIIZ,_
      BYVAL BufferLen       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'HGLOBAL DLLENTRY SSClipValueOut(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                SS_COORD Col2, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSClipValueOut LIB "SPR32D30.DLL" ALIAS "SSClipValueOut" ( _
      BYVAL hWnd            AS LONG,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG _
    )AS DWORD
'---------------------------------------------------------------------------
'int  DLLENTRY SSColWidthToLogUnits(HWND hWnd, double dfColWidth);

DECLARE _
  FUNCTION _
    SSColWidthToLogUnits LIB "SPR32D30.DLL" ALIAS "SSColWidthToLogUnits" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL dfColWidth      AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'LRESULT DLLENTRY SSComboBoxSendMessage(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                       UINT uMsg, WPARAM wParam,
'                                       LPARAM lParam);

DECLARE _
  FUNCTION _
    SSComboBoxSendMessage LIB "SPR32D30.DLL" ALIAS "SSComboBoxSendMessage" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL uMsg            AS DWORD,_
      BYVAL wParam          AS DWORD,_
      BYVAL lParam          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSCopyRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                          SS_COORD Col2, SS_COORD Row2,
'                          SS_COORD ColDest, SS_COORD RowDest);

DECLARE _
  FUNCTION _
    SSCopyRange LIB "SPR32D30.DLL" ALIAS "SSCopyRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL RoW2            AS LONG,_
      BYVAL ColDest         AS LONG,_
      BYVAL RowDest         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSDelCol(HWND hWnd, SS_COORD Col);

DECLARE _
  FUNCTION _
    SSDelCol LIB "SPR32D30.DLL" ALIAS "SSDelCol" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSDelColRange(HWND hWnd, SS_COORD Col, SS_COORD Col2);

DECLARE _
  FUNCTION _
    SSDelColRange LIB "SPR32D30.DLL" ALIAS "SSDelColRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Col2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSDelRow(HWND hWnd, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSDelRow LIB "SPR32D30.DLL" ALIAS "SSDelRow" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSDelRowRange(HWND hWnd, SS_COORD Row, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSDelRowRange LIB "SPR32D30.DLL" ALIAS "SSDelRowRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL Row2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSDeSelectBlock(HWND hWnd);

DECLARE _
  FUNCTION _
    SSDeSelectBlock LIB "SPR32D30.DLL" ALIAS "SSDeSelectBlock" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'------------------------------------------------------------------------------
'int  DLLENTRY SSEnumCustomFunction(HWND hWnd, LPCTSTR lpszPrevFunc,

DECLARE _
  FUNCTION _
    SSEnumCustomFunction LIB "SPR32D30.DLL" ALIAS "SSEnumCustomFunction"( _
	     BYVAL hWnd			AS DWORD, _
		        lpszPrevFunc	AS ASCIIZ _
  )AS LONG
'------------------------------------------------------------------------------
'int  DLLENTRY SSEnumCustomFunctionLen(HWND hWnd, LPCTSTR lpszPrevFunc);
DECLARE _
  FUNCTION _
   SSEnumCustomFunctionLen  LIB "SPR32D30.DLL" ALIAS "SSEnumCustomFunctionLen"( _
	     BYVAL hWnd			AS DWORD, _
		        lpszPrevFunc	AS ASCIIZ _
  )AS LONG

'---------------------------------------------------------------------------
'void DLLENTRY SSFloatFormat(HWND hWnd, LPSS_CELLTYPE lpCellType,
'                            double dfVal, LPTSTR lpszText, BOOL fValue);

DECLARE _
  SUB _
    SSFloatFormat LIB "SPR32D30.DLL" ALIAS "SSFloatFormat" ( _
      BYVAL hWnd            AS DWORD,_
            lpCellType      AS SS_CELLTYPE,_
      BYVAL dfVal           AS DOUBLE,_
            lpszText        AS ASCIIZ,_
      BYVAL fValue          AS LONG _
    )
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetActiveCell(HWND hWnd, LPSS_COORD Col, LPSS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetActiveCell LIB "SPR32D30.DLL" ALIAS "SSGetActiveCell" ( _
      BYVAL hWnd            AS DWORD,_
            Col             AS LONG,_
            Row             AS LONG _
    ) AS LONG
_'---------------------------------------------------------------------------
'void DLLENTRY SSGetAutoSizeVisible(HWND hWnd, LPSS_COORD lpVisibleCols,
'                                   LPSS_COORD lpVisibleRows);

DECLARE _
  SUB _
    SSGetAutoSizeVisible LIB "SPR32D30.DLL" ALIAS "SSGetAutoSizeVisible" ( _
      BYVAL hWnd            AS DWORD,_
            lpVisibleCols   AS LONG,_
            lpVisibleRows   AS LONG _
    )
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetBackColorStyle(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetBackColorStyle LIB "SPR32D30.DLL" ALIAS "SSGetBackColorStyle" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetBool(HWND hWnd, short nIndex);

DECLARE _
  FUNCTION _
    SSGetBool LIB "SPR32D30.DLL" ALIAS "SSGetBool" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL nIndex          AS INTEGER _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetBorder(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                          LPWORD lpwBorderType, LPWORD lpwBorderStyle,
'                          LPCOLORREF lpColor);

DECLARE _
  FUNCTION _
    SSGetBorder LIB "SPR32D30.DLL" ALIAS "SSGetBorder" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpwBorderType   AS CWORD,_
            lpBorderStyle   AS CWORD,_
            lpColor         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------

'#ifdef SS_USE16BITCOORDS
'LONG DLLENTRY SSGetBottomRightCell(HWND hWnd);
'#else
'BOOL DLLENTRY SSGetBottomRightCell(HWND hWnd, LPSS_COORD lpCol,
'                                   LPSS_COORD lpRow);
'#endif

DECLARE _
  FUNCTION _
    SSGetBottomRightCell LIB "SPR32D30.DLL" ALIAS "SSGetBottomRightCell" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetButtonDrawMode(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetButtonDrawMode LIB "SPR32D30.DLL" ALIAS "SSGetButtonDrawMode" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetButtonText(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                              LPTSTR lpText);

DECLARE _
  FUNCTION _
    SSGetButtonText LIB "SPR32D30.DLL" ALIAS "SSGetButtonText" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpText          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'WNDPROC DLLENTRY SSGetCallBack(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetCallBack LIB "SPR32D30.DLL" ALIAS "SSGetCallBack" ( _
      BYVAL hWnd            AS DWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetCellFromPixel(HWND hWnd, LPSS_COORD lpCol,
'                                 LPSS_COORD lpRow, int MouseX, int MouseY);

DECLARE _
  FUNCTION _
    SSGetCellFromPixel LIB "SPR32D30.DLL" ALIAS "SSGetCellFromPixel" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG,_
      BYVAL MouseX          AS LONG,_
      BYVAL MouseY          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetCellRect(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                            LPRECT lpRect);

DECLARE _
  FUNCTION _
    SSGetCellRect LIB "SPR32D30.DLL" ALIAS "SSGetCellRect" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpRect          AS RECT _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSGetCellSendingMsg(HWND hWnd, LPSS_COORD lpCol,
'                                  LPSS_COORD lpRow);

DECLARE _
  SUB _
    SSGetCellSendingMsg LIB "SPR32D30.DLL" ALIAS "SSGetCellSendingMsg" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    )
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetCellType(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                            LPSS_CELLTYPE CellType);

DECLARE _
  FUNCTION _
    SSGetCellType LIB "SPR32D30.DLL" ALIAS "SSGetCellType" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            CellType        AS SS_CELLTYPE _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSGetClientRect(HWND hWnd, LPRECT lpRect);

DECLARE _
  SUB _
    SSGetClientRect LIB "SPR32D30.DLL" ALIAS "SSGetClientRect" ( _
      BYVAL hWnd            AS DWORD,_
            lpRect          AS RECT _
    )
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetColHeaderDisplay(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetColHeaderDisplay LIB "SPR32D30.DLL" ALIAS "SSGetColHeaderDisplay" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetColor(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                         LPCOLORREF lpBackground, LPCOLORREF lpForeground);

DECLARE _
  FUNCTION _
    SSGetColor LIB "SPR32D30.DLL" ALIAS "SSGetColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpBackground    AS LONG,_
            lpForeground    AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetColPageBreak(HWND hWnd, SS_COORD Col);

DECLARE _
  FUNCTION _
    SSGetColPageBreak LIB "SPR32D30.DLL" ALIAS "SSGetColPageBreak" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetColUserData(HWND hWnd, SS_COORD Col, LPLONG lplUserData);

DECLARE _
  FUNCTION _
    SSGetColUserData LIB "SPR32D30.DLL" ALIAS "SSGetColUserData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
            lpUserData      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetColWidth(HWND hWnd, SS_COORD Col, LPDOUBLE lpdfColWidth);

DECLARE _
  FUNCTION _
    SSGetColWidth LIB "SPR32D30.DLL" ALIAS "SSGetColWidth" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
            lpdfColWidth    AS DOUBLE _
    )AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetColWidthInPixels(HWND hWnd, SS_COORD Col, LPINT lpdWidth);

DECLARE _
  FUNCTION _
    SSGetColWidthInPixels LIB "SPR32D30.DLL" ALIAS "SSGetColWidthInPixels" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
            lpWidth         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetCurrSelBlockPos(HWND hWnd, LPSS_COORD CurrentCol,
'                                   LPSS_COORD CurrentRow);

DECLARE _
  FUNCTION _
    SSGetCurrSelBlockPos LIB "SPR32D30.DLL" ALIAS "SSGetCurrSelBlockPos" ( _
      BYVAL hWnd            AS DWORD,_
            CurrentCol      AS LONG,_
            CurrentRow      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'HCURSOR DLLENTRY SSGetCursor(HWND hWnd, CWORD wType);

DECLARE _
  FUNCTION _
    SSGetCursor LIB "SPR32D30.DLL" ALIAS "SSGetCursor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wType           AS CWORD _
    ) AS DWORD
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetCustomFunction(HWND hWnd, LPCTSTR lpszFunc,
'                                  LPSHORT lpnMinParamCnt,
'                                  LPSHORT lpnMaxParamCnt,
'                                  LPLONG lplFlags);
DECLARE _
  FUNCTION _
    SSGetCustomFunction LIB "SPR32D30.DLL" ALIAS "SSGetCustomFunction"( _
	   BYVAL hWnd				AS DWORD, _
		      lpszFunc			AS ASCIIZ, _
            lpnMinParamCnt	AS INTEGER, _
            lpnMaxParamCnt AS INTEGER, _
            lplFlags			AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetCustomName(HWND hWnd, LPCTSTR lpszName,
'                              LPTSTR lpszValue, int nValueLen);

DECLARE _
  FUNCTION _
    SSGetCustomName LIB "SPR32D30.DLL" ALIAS "SSGetCustomName" ( _
      BYVAL hWnd            AS DWORD,_
            lpszName        AS ASCIIZ,_
            lpszValue       AS ASCIIZ,_
      BYVAL nValueLen       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetCustomNameLen(HWND hWnd, LPCTSTR lpszName);

DECLARE _
  FUNCTION _
    SSGetCustomNameLen LIB "SPR32D30.DLL" ALIAS "SSGetCustomNameLen" ( _
      BYVAL hWnd            AS DWORD,_
            lpszName        AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetData(HWND hWnd, SS_COORD Col, SS_COORD Row, LPTSTR Data);

DECLARE _
  FUNCTION _
    SSGetData LIB "SPR32D30.DLL" ALIAS "SSGetData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpData          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetDataCnt(HWND hWnd, LPSS_COORD lpColCnt,
'                           LPSS_COORD lpRowCnt);

DECLARE _
  FUNCTION _
    SSGetDataCnt LIB "SPR32D30.DLL" ALIAS "SSGetDataCnt" ( _
      BYVAL hWnd            AS DWORD,_
            lpColCnt        AS LONG,_
            lpRowCnt        AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetDataLen(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetDataLen LIB "SPR32D30.DLL" ALIAS "SSGetDataLen" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetDefFloatFormat(HWND hWnd, LPSS_FLOATFORMAT lpFloatFormat);

DECLARE _
  FUNCTION _
    SSGetDefFloatFormat LIB "SPR32D30.DLL" ALIAS "SSGetDefFloatFormat" ( _
      BYVAL hWnd            AS DWORD,_
            lpFloatFormat   AS tagSS_FLOATFORMAT _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetEditEnterAction(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetEditEnterAction LIB "SPR32D30.DLL" ALIAS "SSGetEditEnterAction" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetEditMode(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetEditMode LIB "SPR32D30.DLL" ALIAS "SSGetEditMode" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetFirstValidCell(HWND hWnd, LPSS_COORD lpCol,
'                                  LPSS_COORD lpRow);

DECLARE _
  FUNCTION _
    SSGetFirstValidCell LIB "SPR32D30.DLL" ALIAS "SSGetFirstValidCell" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetFloat(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                       LPDOUBLE lpdfValue);

DECLARE _
  FUNCTION _
    SSGetFloat LIB "SPR32D30.DLL" ALIAS "SSGetFloat" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpdfValue       AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'HFONT DLLENTRY SSGetFont(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetFont LIB "SPR32D30.DLL" ALIAS "SSGetFont" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetFormula(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           LPTSTR lpFormula);

DECLARE _
  FUNCTION _
    SSGetFormula LIB "SPR32D30.DLL" ALIAS "SSGetFormula" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpFormula       AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetFormulaLen(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetFormulaLen LIB "SPR32D30.DLL" ALIAS "SSGetFormulaLen" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS INTEGER
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetFreeze(HWND hWnd, LPSS_COORD lpColsFrozen,
'                          LPSS_COORD lpRowsFrozen);

DECLARE _
  FUNCTION _
    SSGetFreeze LIB "SPR32D30.DLL" ALIAS "SSGetFreeze" ( _
      BYVAL hWnd            AS DWORD,_
            lpColsFrozen    AS LONG,_
            lpRowsFrozen    AS LONG _
    )AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSGetGrayAreaColor(HWND hWnd, LPCOLORREF lpBackground,
'                                 LPCOLORREF lpForeground);

DECLARE _
  SUB _
    SSGetGrayAreaColor LIB "SPR32D30.DLL" ALIAS "SSGetGrayAreaColor" ( _
      BYVAL hWnd            AS DWORD,_
            lpBackground    AS LONG,_
            lpForeground    AS LONG _
    )
'---------------------------------------------------------------------------
'COLORREF DLLENTRY SSGetGridColor(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetGridColor LIB "SPR32D30.DLL" ALIAS "SSGetGridColor" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetGridType(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetGridType LIB "SPR32D30.DLL" ALIAS "SSGetGridType" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetInteger(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           LPLONG lplValue);

DECLARE _
  FUNCTION _
    SSGetInteger LIB "SPR32D30.DLL" ALIAS "SSGetInteger" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lplValue        AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetIteration(HWND hWnd, LPSHORT lpnMaxIterations,
'                             LPDOUBLE lpdfMaxChange);

DECLARE _
  FUNCTION _
    SSGetIteration LIB "SPR32D30.DLL" ALIAS "SSGetIteration" ( _
      BYVAL hWnd            AS DWORD,_
            lpMaxIterations AS INTEGER,_
            lpdfMaxChange   AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetLastValidCell(HWND hWnd, LPSS_COORD lpCol,
'                                 LPSS_COORD lpRow);

DECLARE _
  FUNCTION _
    SSGetLastValidCell LIB "SPR32D30.DLL" ALIAS "SSGetLastValidCell" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetLock(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetLock LIB "SPR32D30.DLL" ALIAS "SSGetLock" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSGetLockColor(HWND hWnd, LPCOLORREF lpBackground,
'                             LPCOLORREF lpForeground);

DECLARE _
  SUB _
    SSGetLockColor LIB "SPR32D30.DLL" ALIAS "SSGetLockColor" ( _
      BYVAL hWnd            AS DWORD,_
            lpBackground    AS LONG,_
            lpForeground    AS LONG _
    )
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSGetMaxCols(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetMaxCols LIB "SPR32D30.DLL" ALIAS "SSGetMaxCols" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSGetMaxRows(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetMaxRows LIB "SPR32D30.DLL" ALIAS "SSGetMaxRows" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetMaxTextCellSize(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                   LPDOUBLE lpdfWidth, LPDOUBLE lpdfHeight);

DECLARE _
  FUNCTION _
    SSGetMaxTextCellSize LIB "SPR32D30.DLL" ALIAS "SSGetMaxTextCellSize" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpdfWidth       AS DOUBLE,_
            lpdfHeight      AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetMaxTextColWidth(HWND hWnd, SS_COORD Col,
'                                   LPDOUBLE lpdfColWidth);

DECLARE _
  FUNCTION _
    SSGetMaxTextColWidth LIB "SPR32D30.DLL" ALIAS "SSGetMaxTextColWidth" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
            lpdfColWidth    AS DOUBLE _
    )AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetMaxTextRowHeight(HWND hWnd, SS_COORD Row,
'                                    LPDOUBLE lpdfRowHeight);

DECLARE _
  FUNCTION _
    SSGetMaxTextRowHeight LIB "SPR32D30.DLL" ALIAS "SSGetMaxTextRowHeight" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
            lpdfRowHeight   AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'HGLOBAL DLLENTRY SSGetMultiSelBlocks(HWND hWnd, LPSHORT lpdSelBlockCnt);
'Note LP to a Short is a dword

DECLARE _
  FUNCTION _
    SSGetMultiSelBlocks LIB "SPR32D30.DLL" ALIAS "SSGetMultiSelBlocks" ( _
      BYVAL hWnd            AS DWORD,_
            lpdSelBlockCnt  AS INTEGER _
    ) AS DWORD
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetOperationMode(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetOperationMode LIB "SPR32D30.DLL" ALIAS "SSGetOperationMode" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'HWND DLLENTRY SSGetOwner(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetOwner LIB "SPR32D30.DLL" ALIAS "SSGetOwner" ( _
      BYVAL hWnd            AS DWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'short DLLENTRY SSGetRefStyle(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetRefStyle LIB "SPR32D30.DLL" ALIAS "SSGetRefStyle" ( _
      BYVAL hWnd            AS DWORD _
    ) AS INTEGER
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetRowHeaderDisplay(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetRowHeaderDisplay LIB "SPR32D30.DLL" ALIAS "SSGetRowHeaderDisplay" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetRowHeight(HWND hWnd, SS_COORD Row, LPDOUBLE lpdfRowHeight);

DECLARE _
  FUNCTION _
    SSGetRowHeight LIB "SPR32D30.DLL" ALIAS "SSGetRowHeight" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
            lpdfRowHeight   AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetRowHeightInPixels(HWND hWnd, SS_COORD Row, LPINT lpdHeight);

DECLARE _
  FUNCTION _
    SSGetRowHeightInPixels LIB "SPR32D30.DLL" ALIAS "SSGetRowHeightInPixels" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
            lpdHeight       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetRowPageBreak(HWND hWnd, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetRowPageBreak LIB "SPR32D30.DLL" ALIAS "SSGetRowPageBreak" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetRowUserData(HWND hWnd, SS_COORD Row, LPLONG lplUserData);

DECLARE _
  FUNCTION _
    SSGetRowUserData LIB "SPR32D30.DLL" ALIAS "SSGetRowUserData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
            lplUserData     AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetSel(HWND hWnd, LPINT SelStart, LPINT SelEnd);

DECLARE _
  FUNCTION _
    SSGetSel LIB "SPR32D30.DLL" ALIAS "SSGetSel" ( _
      BYVAL hWnd            AS DWORD,_
            lpSelStart      AS LONG,_
            lpSelEnd        AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetSelBlockOptions(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetSelBlockOptions LIB "SPR32D30.DLL" ALIAS "SSGetSelBlockOptions" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetSelectBlock(HWND hWnd, LPSS_CELLCOORD CellUL,
'                               LPSS_CELLCOORD CellLR);

DECLARE _
  FUNCTION _
    SSGetSelectBlock LIB "SPR32D30.DLL" ALIAS "SSGetSelectBlock" ( _
      BYVAL hWnd            AS DWORD,_
            CellUL          AS SS_CELLCOORD,_
            CellLR          AS SS_CELLCOORD _
    ) AS LONG
'---------------------------------------------------------------------------
'HGLOBAL DLLENTRY SSGetSelText(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetSelText LIB "SPR32D30.DLL" ALIAS "SSGetSelText" ( _
      BYVAL hWnd            AS DWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'void DLLENTRY SSGetShadowColor(HWND hWnd, LPCOLORREF lpShadowColor,
'                               LPCOLORREF lpShadowText,
'                               LPCOLORREF lpShadowDark,
'                               LPCOLORREF lpShadowLight);

DECLARE _
  SUB _
    SSGetShadowColor LIB "SPR32D30.DLL" ALIAS "SSGetShadowColor" ( _
      BYVAL hWnd            AS DWORD,_
            lpShadowColor   AS LONG,_
            lpShadowText    AS LONG,_
            lpShadowDark    AS LONG,_
            lpShadowLight   AS LONG _
    )
'---------------------------------------------------------------------------
'void DLLENTRY SSGetStartingNumbers(HWND hWnd, LPSS_COORD lpStartingColNumber,
'                                   LPSS_COORD lpStartingRowNumber);

DECLARE _
  SUB _
    SSGetStartingNumbers LIB "SPR32D30.DLL" ALIAS "SSGetStartingNumbers" ( _
      BYVAL hWnd                AS DWORD,_
            lpStartingColNumber AS LONG,_
            lpStartingRowNumber AS LONG _
    )
'---------------------------------------------------------------------------
'#ifdef SS_USE16BITCOORDS
'LONG DLLENTRY SSGetTopLeftCell(HWND hWnd);
'#else
'BOOL DLLENTRY SSGetTopLeftCell(HWND hWnd, LPSS_COORD lpCol, LPSS_COORD lpRow);

DECLARE _
  FUNCTION _
    SSGetTopLeftCell LIB "SPR32D30.DLL" ALIAS "SSGetTopLeftCell" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSGetTopLeftPrev(HWND hWnd, LPSS_COORD lpCol, LPSS_COORD lpRow);

DECLARE _
  SUB _
    SSGetTopLeftPrev LIB "SPR32D30.DLL" ALIAS "SSGetTopLeftPrev" ( _
      BYVAL hWnd            AS DWORD,_
            lpCol           AS LONG,_
            lpRow           AS LONG _
    )
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetUnitType(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetUnitType LIB "SPR32D30.DLL" ALIAS "SSGetUnitType" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'LONG DLLENTRY SSGetUserData(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetUserData LIB "SPR32D30.DLL" ALIAS "SSGetUserData" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSGetUserResize(HWND hWnd);

DECLARE _
  FUNCTION _
    SSGetUserResize LIB "SPR32D30.DLL" ALIAS "SSGetUserResize" ( _
      BYVAL hWnd            AS DWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'short DLLENTRY SSGetUserResizeCol(HWND hWnd, SS_COORD Col);

DECLARE _
  FUNCTION _
    SSGetUserResizeCol LIB "SPR32D30.DLL" ALIAS "SSGetUserResizeCol" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG _
    ) AS INTEGER
'---------------------------------------------------------------------------
'short DLLENTRY SSGetUserResizeRow(HWND hWnd, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetUserResizeRow LIB "SPR32D30.DLL" ALIAS "SSGetUserResizeRow" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG _
    ) AS INTEGER
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetValue(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                         LPTSTR lpBuffer);

DECLARE _
  FUNCTION _
    SSGetValue LIB "SPR32D30.DLL" ALIAS "SSGetValue" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpszBuffer      AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSGetValueLen(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSGetValueLen LIB "SPR32D30.DLL" ALIAS "SSGetValueLen" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSGetVisible(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           short Visible);

DECLARE _
  FUNCTION _
    SSGetVisible LIB "SPR32D30.DLL" ALIAS "SSGetVisible" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL xVisible         AS INTEGER _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSInsCol(HWND hWnd, SS_COORD Col);

DECLARE _
  FUNCTION _
    SSInsCol LIB "SPR32D30.DLL" ALIAS "SSInsCol" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSInsColRange(HWND hWnd, SS_COORD Col, SS_COORD Col2);

DECLARE _
  FUNCTION _
    SSInsColRange LIB "SPR32D30.DLL" ALIAS "SSInsColRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Col2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSInsRow(HWND hWnd, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSInsRow LIB "SPR32D30.DLL" ALIAS "SSInsRow" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSInsRowRange(HWND hWnd, SS_COORD Row, SS_COORD Row2);

DECLARE _
  FUNCTION _
    SSInsRowRange LIB "SPR32D30.DLL" ALIAS "SSInsRowRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL Row2            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSIsCellInSelection(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSIsCellInSelection LIB "SPR32D30.DLL" ALIAS "SSIsCellInSelection" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSLoadFromBuffer(HWND hWnd, HGLOBAL hBuffer, long lBufferLen);
#IF 1
DECLARE _
  FUNCTION _
    SSLoadFromBuffer LIB "SPR32D30.DLL" ALIAS "SSLoadFromBuffer" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL hBuffer         AS DWORD,_
      BYVAL lBufferLen      AS LONG _
    ) AS LONG
#ENDIF
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSLoadFromFile(HWND hWnd, LPCTSTR lpszFileName);

DECLARE _
  FUNCTION _
    SSLoadFromFile LIB "SPR32D30.DLL" ALIAS "SSLoadFromFile" ( _
      BYVAL hWnd            AS DWORD,_
            lpszFileName    AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSLoadTabFile(HWND hWnd, LPCTSTR lpszFileName);

DECLARE _
  FUNCTION _
    SSLoadTabFile LIB "SPR32D30.DLL" ALIAS "SSLoadTabFile" ( _
      BYVAL hWnd            AS DWORD,_
            lpszFileName    AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSLogUnitsToColWidth(HWND hWnd, int dUnits,
'                                   LPDOUBLE lpdfColWidth);

DECLARE _
  SUB _
    SSLogUnitsToColWidth LIB "SPR32D30.DLL" ALIAS "SSLogUnitsToColWidth" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL dUnits          AS LONG,_
            lpdfColWidth    AS DOUBLE _
    )
'---------------------------------------------------------------------------
'void DLLENTRY SSLogUnitsToRowHeight(HWND hWnd, SS_COORD Row, int dUnits,
'                                    LPDOUBLE lpdfRowHeight);

DECLARE _
  SUB _
    SSLogUnitsToRowHeight LIB "SPR32D30.DLL" ALIAS "SSLogUnitsToRowHeight" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
            lpdfRowHeight   AS DOUBLE _
    )
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSMoveRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                          SS_COORD Col2, SS_COORD Row2,
'                          SS_COORD ColDest, SS_COORD RowDest);

DECLARE _
  FUNCTION _
    SSMoveRange LIB "SPR32D30.DLL" ALIAS "SSMoveRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL ColDest         AS LONG,_
      BYVAL RowDest         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSPrint(HWND hWnd, LPCTSTR lpszPrintJobName,
'                      LPSS_PRINTFORMAT lpPrintFormat,
'                      SS_PRINTFUNC lpfnPrintProc, LONG lAppData,
'                      ABORTPROC lpfnAbortProc);

DECLARE _
  FUNCTION _
    SSPrint LIB "SPR32D30.DLL" ALIAS "SSPrint" ( _
      BYVAL hWnd                AS DWORD,_
            lpszPrintJobName    AS ASCIIZ,_
            lpPrintFormat       AS SS_PRINTFORMAT,_
      BYVAL fnPrintProc         AS DWORD,_
      BYVAL lAppData            AS LONG,_
      BYVAL fnAbortProc         AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSQueryCustomName(HWND hWnd, LPCTSTR lpszPrevName,
'                                LPTSTR lpszName, int nNameLen);

DECLARE _
  FUNCTION _
    SSQueryCustomName LIB "SPR32D30.DLL" ALIAS "SSQueryCustomName" ( _
      BYVAL hWnd            AS DWORD,_
            lpszPrevName    AS ASCIIZ,_
            lpszName        AS ASCIIZ,_
      BYVAL nNameLen        AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSQueryCustomNameLen(HWND hWnd, LPCTSTR lpszPrevName);

DECLARE _
  FUNCTION _
    SSQueryCustomNameLen LIB "SPR32D30.DLL" ALIAS "SSQueryCustomNameLen" ( _
      BYVAL hWnd            AS DWORD,_
            lpszPrevName    AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSReCalc(HWND hWnd);

DECLARE _
  FUNCTION _
    SSReCalc LIB "SPR32D30.DLL" ALIAS "SSReCalc" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSReCalcCell(HWND hWnd, SS_COORD lCol, SS_COORD lRow);
DECLARE _
  FUNCTION _
    SSReCalcCell LIB "SPR32D30.DLL" ALIAS  "SSReCalcCell"( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lCol				AS LONG, _
		BYVAL lRow				AS LONG _
	) AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSRemoveCustomFunction(HWND hWnd, LPCTSTR lpszFuncName);
DECLARE _
  FUNCTION _
    SSRemoveCustomFunction LIB "SPR32D30.DLL" ALIAS "SSRemoveCustomFunction"( _
      BYVAL hWnd				AS DWORD, _
		    	lpszFuncName	AS ASCIIZ _
	)AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSReplaceSel(HWND hWnd, LPCTSTR lpText);

DECLARE _
  FUNCTION _
    SSReplaceSel LIB "SPR32D30.DLL" ALIAS "SSReplaceSel" ( _
      BYVAL hWnd            AS DWORD,_
            lpszText        AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSReset(HWND hWnd);

DECLARE _
  FUNCTION _
    SSReset LIB "SPR32D30.DLL" ALIAS "SSReset" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'int  DLLENTRY SSRowHeightToLogUnits(HWND hWnd, SS_COORD Row,
'                                    double dfRowHeight);

DECLARE _
  FUNCTION _
    SSRowHeightToLogUnits LIB "SPR32D30.DLL" ALIAS "SSRowHeightToLogUnits" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL dfRowHeight     AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSaveTabFile(HWND hWnd, LPCTSTR lpszFileName);

DECLARE _
  FUNCTION _
    SSSaveTabFile LIB "SPR32D30.DLL" ALIAS "SSSaveTabFile" ( _
      BYVAL hWnd            AS DWORD,_
            lpszFileName    AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'HGLOBAL DLLENTRY SSSaveToBuffer(HWND hWnd, LPLONG lpBufferLen, BOOL fDataOnly);

DECLARE _
  FUNCTION _
    SSSaveToBuffer LIB "SPR32D30.DLL" ALIAS "SSSaveToBuffer" ( _
      BYVAL hWnd            AS DWORD,_
            lpBufferLen     AS LONG,_
      BYVAL fDataOnly       AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSaveToFile(HWND hWnd, LPCTSTR lpszFileName, BOOL fDataOnly);

DECLARE _
  FUNCTION _
    SSSaveToFile LIB "SPR32D30.DLL" ALIAS "SSSaveToFile" ( _
      BYVAL hWnd            AS DWORD,_
            lpszFileName    AS ASCIIZ,_
      BYVAL fDataOnly       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'long DLLENTRY SSSelModeSendMessage(HWND hWnd, UINT uMsg, long lParam1,
'                                   long lParam2, long lParam3);

DECLARE _
  FUNCTION _
    SSSelModeSendMessage LIB "SPR32D30.DLL" ALIAS "SSSelModeSendMessage" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL uMsg            AS DWORD,_
      BYVAL lParam1         AS LONG,_           'may be a potential problem using long
      BYVAL lParam2         AS LONG,_           'instead of dword??
      BYVAL lParam3         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetActiveCell(HWND hWnd, SS_COORD Col, SS_COORD Row);

DECLARE _
  FUNCTION _
    SSSetActiveCell LIB "SPR32D30.DLL" ALIAS "SSSetActiveCell" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSSetAutoSizeVisible(HWND hWnd, SS_COORD VisibleCols,
'                                   SS_COORD VisibleRows);

DECLARE _
  SUB _
    SSSetAutoSizeVisible LIB "SPR32D30.DLL" ALIAS "SSSetAutoSizeVisible" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL VisibleCols     AS LONG,_
      BYVAL VisibleRows     AS LONG _
    )
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetBackColorStyle(HWND hWnd, WORD wStyle);

DECLARE _
  FUNCTION _
    SSSetBackColorStyle LIB "SPR32D30.DLL" ALIAS "_SSSetBackColorStyle@8" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wStyle          AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetBool(HWND hWnd, short nIndex, BOOL bNewVal);

DECLARE _
  FUNCTION _
    SSSetBool LIB "SPR32D30.DLL" ALIAS "SSSetBool" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL nIndex          AS INTEGER,_
      BYVAL bNewVal         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetBorder(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                          WORD wBorderType, WORD wBorderStyle,
'                          COLORREF Color);

DECLARE _
  FUNCTION _
    SSSetBorder LIB "SPR32D30.DLL" ALIAS "SSSetBorder" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL wBorderType     AS CWORD,_
      BYVAL wBorderStyle    AS CWORD,_
      BYVAL nColor           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetBorderRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                               SS_COORD Col2, SS_COORD Row2,
'                               WORD wBorderType, WORD wBorderStyle,
'                               COLORREF Color);

DECLARE _
  FUNCTION _
    SSSetBorderRange LIB "SPR32D30.DLL" ALIAS "SSSetBorderRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL wBorderType     AS CWORD,_
      BYVAL wBorderStyle    AS CWORD,_
      BYVAL nColor           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetButtonDrawMode(HWND hWnd, WORD wMode);

DECLARE _
  FUNCTION _
    SSSetButtonDrawMode LIB "SPR32D30.DLL" ALIAS "SSSetButtonDrawMode" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wMode           AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetButtonText(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                              LPCTSTR lpText);

DECLARE _
  FUNCTION _
    SSSetButtonText LIB "SPR32D30.DLL" ALIAS "SSSetButtonText" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpszText        AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'WNDPROC DLLENTRY SSSetCallBack(HWND hWnd, WNDPROC lpfnCallBack);

DECLARE _
  FUNCTION _
    SSSetCallBack LIB "SPR32D30.DLL" ALIAS "SSSetCallBack" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL fnCallBack      AS DWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetCellType(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                            LPSS_CELLTYPE CellType);

DECLARE _
  FUNCTION _
    SSSetCellType LIB "SPR32D30.DLL" ALIAS "SSSetCellType" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpCellType      AS SS_CELLTYPE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetCellTypeRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                 SS_COORD Col2, SS_COORD Row2,
'                                 LPSS_CELLTYPE CellType);

DECLARE _
  FUNCTION _
    SSSetCellTypeRange LIB "SPR32D30.DLL" ALIAS "SSSetCellTypeRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
            lpCellType      AS SS_CELLTYPE _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetColHeaderDisplay(HWND hWnd, WORD wDisplay);

DECLARE _
  FUNCTION _
    SSSetColHeaderDisplay LIB "SPR32D30.DLL" ALIAS "SSSetColHeaderDisplay" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wDisplay        AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColor(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                         COLORREF Background, COLORREF Foreground);

DECLARE _
  FUNCTION _
    SSSetColor LIB "SPR32D30.DLL" ALIAS "SSSetColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Background      AS LONG,_
      BYVAL Foreground      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColorRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                              SS_COORD Col2, SS_COORD Row2,
'                              COLORREF Background, COLORREF Foreground);

DECLARE _
  FUNCTION _
    SSSetColorRange LIB "SPR32D30.DLL" ALIAS "SSSetColorRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL Background      AS LONG,_
      BYVAL Foreground      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColPageBreak(HWND hWnd, SS_COORD Col, BOOL fPageBreak);

DECLARE _
  FUNCTION _
    SSSetColPageBreak LIB "SPR32D30.DLL" ALIAS "SSSetColPageBreak" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL fPageBreak      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColUserData(HWND hWnd, SS_COORD Col, long lUserData);

DECLARE _
  FUNCTION _
    SSSetColUserData LIB "SPR32D30.DLL" ALIAS "SSSetColUserData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL lUserData       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColWidth(HWND hWnd, SS_COORD Col, double dfWidth);

DECLARE _
  FUNCTION _
    SSSetColWidth LIB "SPR32D30.DLL" ALIAS "SSSetColWidth" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL dfWidth         AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetColWidthInPixels(HWND hWnd, SS_COORD Col, int dWidth);

DECLARE _
  FUNCTION _
    SSSetColWidthInPixels LIB "SPR32D30.DLL" ALIAS "SSSetColWidthInPixels" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL dWidth          AS LONG _
    )AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetCursor(HWND hWnd, WORD wType, HCURSOR hCursor);

DECLARE _
  FUNCTION _
    SSSetCursor LIB "SPR32D30.DLL" ALIAS "SSSetCursor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wType           AS CWORD,_
      BYVAL hCursor         AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetCustomName(HWND hWnd, LPCTSTR lpszName, LPCTSTR lpszValue);

DECLARE _
  FUNCTION _
    SSSetCustomName LIB "SPR32D30.DLL" ALIAS "SSSetCustomName" ( _
      BYVAL hWnd            AS DWORD,_
            lpszName        AS ASCIIZ,_
            lpszValue       AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetData(HWND hWnd, SS_COORD Col, SS_COORD Row, LPCTSTR lpData);

DECLARE _
  FUNCTION _
    SSSetData LIB "SPR32D30.DLL" ALIAS "SSSetData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpData          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetDataRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                             SS_COORD Col2, SS_COORD Row2, LPCTSTR lpData);

DECLARE _
  FUNCTION _
    SSSetDataRange LIB "SPR32D30.DLL" ALIAS "SSSetDataRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
            lpData          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetDefFloatFormat(HWND hWnd, LPSS_FLOATFORMAT lpFloatFormat);

DECLARE _
  FUNCTION _
    SSSetDefFloatFormat LIB "SPR32D30.DLL" ALIAS "SSSetDefFloatFormat" ( _
      BYVAL hWnd            AS DWORD,_
            lpFloatFormat   AS tagSS_FLOATFORMAT _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetEditEnterAction(HWND hWnd, WORD wAction);

DECLARE _
  FUNCTION _
    SSSetEditEnterAction LIB "SPR32D30.DLL" ALIAS "SSSetEditEnterAction" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wAction         AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetEditMode(HWND hWnd, BOOL fEditModeOn);

DECLARE _
  FUNCTION _
    SSSetEditMode LIB "SPR32D30.DLL" ALIAS "SSSetEditMode" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL fEditModeOn     AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFloat(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                         double dfValue);

DECLARE _
  FUNCTION _
    SSSetFloat LIB "SPR32D30.DLL" ALIAS "SSSetFloat" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL dfValue         AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFloatRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                              SS_COORD Col2, SS_COORD Row2, double dfValue);

DECLARE _
  FUNCTION _
    SSSetFloatRange LIB "SPR32D30.DLL" ALIAS "SSSetFloatRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL dfValue         AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFont(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                        HFONT hFont, BOOL fDeleteFont);

DECLARE _
  FUNCTION _
    SSSetFont LIB "SPR32D30.DLL" ALIAS "SSSetFont" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL hFont           AS DWORD,_
      BYVAL fDeleteFont     AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFontRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                             SS_COORD Col2, SS_COORD Row2,
'                             HFONT hFont, BOOL fDeleteFont);

DECLARE _
  FUNCTION _
    SSSetFontRange LIB "SPR32D30.DLL" ALIAS "SSSetFontRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL hFont           AS DWORD,_
      BYVAL fDeleteFont     AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFormula(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                           LPCTSTR Formula, BOOL BuildDependencies);

DECLARE _
  FUNCTION _
    SSSetFormula LIB "SPR32D30.DLL" ALIAS "SSSetFormula" ( _
      BYVAL hWnd                AS DWORD,_
      BYVAL Col                 AS LONG,_
      BYVAL Row                 AS LONG,_
            lpszFormula         AS ASCIIZ,_
      BYVAL BuildDependencies   AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFormulaRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                SS_COORD Col2, SS_COORD Row2,
'                                LPCTSTR Formula, BOOL BuildDependencies);

DECLARE _
  FUNCTION _
    SSSetFormulaRange LIB "SPR32D30.DLL" ALIAS "SSSetFormulaRange" ( _
      BYVAL hWnd                AS DWORD,_
      BYVAL Col                 AS LONG,_
      BYVAL Row                 AS LONG,_
      BYVAL Col2                AS LONG,_
      BYVAL Row2                AS LONG,_
            lpszFormula         AS ASCIIZ,_
      BYVAL BuildDependencies   AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetFreeze(HWND hWnd, SS_COORD ColsFrozen, SS_COORD RowsFrozen);

DECLARE _
  FUNCTION _
    SSSetFreeze LIB "SPR32D30.DLL" ALIAS "SSSetFreeze" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL ColsFrozen      AS LONG,_
      BYVAL RowsFrozen      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSSetGrayAreaColor(HWND hWnd, COLORREF Background,
'                                 COLORREF Foreground);

DECLARE _
  SUB _
    SSSetGrayAreaColor LIB "SPR32D30.DLL" ALIAS "SSSetGrayAreaColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Background      AS LONG,_
      BYVAL Foreground      AS LONG _
    )
'---------------------------------------------------------------------------
'COLORREF DLLENTRY SSSetGridColor(HWND hWnd, COLORREF Color);

DECLARE _
  FUNCTION _
    SSSetGridColor LIB "SPR32D30.DLL" ALIAS "SSSetGridColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL nColor           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetGridType(HWND hWnd, WORD wGridType);

DECLARE _
  FUNCTION _
    SSSetGridType LIB "SPR32D30.DLL" ALIAS "SSSetGridType" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wGridType       AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetInteger(HWND hWnd, SS_COORD Col, SS_COORD Row, long lValue);

DECLARE _
  FUNCTION _
    SSSetInteger LIB "SPR32D30.DLL" ALIAS "SSSetInteger" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL lValue          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetIntegerRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                                SS_COORD Col2, SS_COORD Row2, long lValue);

DECLARE _
  FUNCTION _
    SSSetIntegerRange LIB "SPR32D30.DLL" ALIAS "SSSetIntegerRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL lValue          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetIteration(HWND hWnd, BOOL bIteration,
'                             short nMaxIterations, double dfMaxChange);

DECLARE _
  FUNCTION _
    SSSetIteration LIB "SPR32D30.DLL" ALIAS "SSSetIteration" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL bIteration      AS LONG,_
      BYVAL nMaxIterations  AS INTEGER,_
      BYVAL dfMaxChange     AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetLock(HWND hWnd, SS_COORD Col, SS_COORD Row, BOOL Lock);

DECLARE _
  FUNCTION _
    SSSetLock LIB "SPR32D30.DLL" ALIAS "SSSetLock" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL bLock           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSSetLockColor(HWND hWnd, COLORREF Background,
'                             COLORREF Foreground);

DECLARE _
  SUB _
    SSSetLockColor LIB "SPR32D30.DLL" ALIAS "SSSetLockColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Background      AS LONG,_
      BYVAL Foreground      AS LONG _
    )
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetLockRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                             SS_COORD Col2, SS_COORD Row2, BOOL Lock);

DECLARE _
  FUNCTION _
    SSSetLockRange LIB "SPR32D30.DLL" ALIAS "SSSetLockRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL bLock           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSSetMaxCols(HWND hWnd, SS_COORD MaxCols);

DECLARE _
  SUB _
    SSSetMaxCols LIB "SPR32D30.DLL" ALIAS "SSSetMaxCols" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL MaxCols         AS LONG _
    )
'---------------------------------------------------------------------------
'void DLLENTRY SSSetMaxRows(HWND hWnd, SS_COORD MaxRows);

DECLARE _
  SUB _
    SSSetMaxRows LIB "SPR32D30.DLL" ALIAS "SSSetMaxRows" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL MaxRows         AS LONG _
    )
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetMultiSelBlocks(HWND hWnd, LPSS_SELBLOCK lpSelBlockList,
'                                  short dSelBlockCnt);

DECLARE _
  FUNCTION _
    SSSetMultiSelBlocks LIB "SPR32D30.DLL" ALIAS "SSSetMultiSelBlocks" ( _
      BYVAL hWnd            AS DWORD,_
            lpSelBlockList  AS SS_SELBLOCK,_
      BYVAL dSelBlockCnt    AS INTEGER _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetOperationMode(HWND hWnd, WORD wMode);

DECLARE _
  FUNCTION _
    SSSetOperationMode LIB "SPR32D30.DLL" ALIAS "SSSetOperationMode" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wMode           AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'HWND DLLENTRY SSSetOwner(HWND hWnd, HWND hWndOwner);

DECLARE _
  FUNCTION _
    SSSetOwner LIB "SPR32D30.DLL" ALIAS "SSSetOwner" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL hWndOwner       AS DWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'short DLLENTRY SSSetRefStyle(HWND hWnd, short nStyle);

DECLARE _
  FUNCTION _
    SSSetRefStyle LIB "SPR32D30.DLL" ALIAS "_SSSetRefStyle@8" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL nStyle          AS INTEGER _
    ) AS INTEGER
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetRowHeaderDisplay(HWND hWnd, WORD wDisplay);

DECLARE _
  FUNCTION _
    SSSetRowHeaderDisplay LIB "SPR32D30.DLL" ALIAS "SSSetRowHeaderDisplay" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wDisplay        AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetRowHeight(HWND hWnd, SS_COORD Row, double dfHeight);

DECLARE _
  FUNCTION _
    SSSetRowHeight LIB "SPR32D30.DLL" ALIAS "SSSetRowHeight" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL dfHeight        AS DOUBLE _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetRowHeightInPixels(HWND hWnd, SS_COORD Row, int dHeight);

DECLARE _
  FUNCTION _
    SSSetRowHeightInPixels LIB "SPR32D30.DLL" ALIAS "SSSetRowHeightInPixels" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL dHeight         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetRowPageBreak(HWND hWnd, SS_COORD Row, BOOL fPageBreak);

DECLARE _
  FUNCTION _
    SSSetRowPageBreak LIB "SPR32D30.DLL" ALIAS "SSSetRowPageBreak" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL fPageBreak      AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetRowUserData(HWND hWnd, SS_COORD Row, long lUserData);

DECLARE _
  FUNCTION _
    SSSetRowUserData LIB "SPR32D30.DLL" ALIAS "SSSetRowUserData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL lUserData       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetSel(HWND hWnd, int SelStart, int SelEnd);

DECLARE _
  FUNCTION _
    SSSetSel LIB "SPR32D30.DLL" ALIAS "SSSetSel" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL SelStart        AS LONG,_
      BYVAL SelEnd          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetSelBlockOptions(HWND hWnd, WORD wOption);

DECLARE _
  FUNCTION _
    SSSetSelBlockOptions LIB "SPR32D30.DLL" ALIAS "SSSetSelBlockOptions" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wOption         AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetSelectBlock(HWND hWnd, LPSS_CELLCOORD CellUL,
'                               LPSS_CELLCOORD CellLR);

DECLARE _
  FUNCTION _
    SSSetSelectBlock LIB "SPR32D30.DLL" ALIAS "SSSetSelectBlock" ( _
      BYVAL hWnd            AS DWORD,_
            CellUL          AS SS_CELLCOORD,_
            CellLR          AS SS_CELLCOORD _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSSetShadowColor(HWND hWnd, COLORREF ShadowColor,
'                               COLORREF ShadowText, COLORREF ShadowDark,
'                               COLORREF ShadowLight);

DECLARE _
  SUB _
    SSSetShadowColor LIB "SPR32D30.DLL" ALIAS "SSSetShadowColor" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL ShadowColor     AS LONG,_
      BYVAL ShadowText      AS LONG,_
      BYVAL ShadowDark      AS LONG,_
      BYVAL ShadowLight     AS LONG _
    )
'---------------------------------------------------------------------------
'void DLLENTRY SSSetStartingNumbers(HWND hWnd, SS_COORD StartingColNumber,
'                                   SS_COORD StartingRowNumber);

DECLARE _
  SUB _
    SSSetStartingNumbers LIB "SPR32D30.DLL" ALIAS "SSSetStartingNumbers" ( _
      BYVAL hWnd                AS DWORD,_
      BYVAL StartingColNumber   AS LONG,_
      BYVAL StartinRowNumber    AS LONG _
    )
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeButton(HWND hWnd, LPSS_CELLTYPE CellType,
'                                       long Style, LPCTSTR Text,
'                                       LPCTSTR Picture, short nPictureType,
'                                       LPCTSTR PictureDown, short nPictureDownType,
'                                       short ButtonType, short nShadowSize,
'                                       LPSUPERBTNCOLOR lpColor);

DECLARE _
  FUNCTION _
    SSSetTypeButton LIB "SPR32D30.DLL" ALIAS "SSSetTypeButton" ( _
      BYVAL hWnd                AS DWORD,_
            lpCellType          AS SS_CELLTYPE,_
      BYVAL Style               AS LONG,_
            lpszText            AS ASCIIZ,_
            lpszPicture         AS ASCIIZ,_
      BYVAL nPictureType        AS INTEGER,_
            lpszPictureDown     AS ASCIIZ,_
      BYVAL nPictureDownType    AS INTEGER,_
      BYVAL ButtonType          AS INTEGER,_
      BYVAL nShadowSize         AS INTEGER,_
            lpColor             AS SUPERBTNCOLOR _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeCheckBox(HWND hWnd, LPSS_CELLTYPE lpCellType,
'                                         long lStyle, LPCTSTR lpText,
'                                         LPCTSTR lpPictUp,
'                                         WORD wPictUpType,
'                                         LPCTSTR lpPictDown,
'                                         WORD wPictDownType,
'                                         LPCTSTR lpPictFocusUp,
'                                         WORD wPictFocusUpType,
'                                         LPCTSTR lpPictFocusDown,
'                                         WORD wPictFocusDownType,
'                                         LPCTSTR lpPictGray,
'                                         WORD wPictGrayType,
'                                         LPCTSTR lpPictFocusGray,
'                                         WORD wPictFocusGrayType);

DECLARE _
  FUNCTION _
    SSSetTypeCheckBox LIB "SPR32D30.DLL" ALIAS "SSSetTypeCheckBox" ( _
      BYVAL hWnd                AS DWORD,_
            lpCellType          AS SS_CELLTYPE,_
      BYVAL lStyle              AS LONG,_
            lpText              AS ASCIIZ,_
            lpPictUp            AS ASCIIZ,_
      BYVAL wPictUpType         AS CWORD,_
            lpPictDown          AS ASCIIZ,_
      BYVAL wPictDownType       AS CWORD,_
            lpPictFocusUp       AS ASCIIZ,_
      BYVAL wPictFocusUpType    AS CWORD,_
            lpPictFocusDown     AS ASCIIZ,_
      BYVAL wPictFocusDownType  AS CWORD,_
            lpPictGray          AS ASCIIZ,_
      BYVAL wPictGrayType       AS CWORD,_
            lpPictFocusGray     AS ASCIIZ,_
      BYVAL wPictFocusGrayType  AS CWORD _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeComboBox(HWND hWnd, LPSS_CELLTYPE CellType,
'                                         long Style, LPCTSTR lpItems);

DECLARE _
  FUNCTION _
    SSSetTypeComboBox LIB "SPR32D30.DLL" ALIAS "SSSetTypeComboBox" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
            lpItems         AS ASCIIZ _
    ) AS DWORD
'------------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeComboBoxEx(HWND hWnd, LPSS_CELLTYPE lpCellType,
'                                           long Style, LPCTSTR lpItems,
'                                           short dMaxRows, short dMaxEditLen,
'                                           short dComboWidth, HWND hWndDropDown);

DECLARE _
  FUNCTION _
    SSSetTypeComboBoxEx LIB "SPR32D30.DLL" ALIAS  "SSSetTypeComboBoxEx" ( _
	   byval HwND				AS DWORD, _
		      lpCellType		AS SS_CELLTYPE, _
		BYVAL Style				AS LONG, _
		      lpItems			AS ASCIIZ, _
	   BYVAL dMaxRows			AS INTEGER, _
		BYVAL dMaxEditLen		AS INTEGER, _
		byval dComboWidth		AS INTEGER, _
		BYVAL hWndDropDown	AS DWORD _
	)AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeDate(HWND hWnd, LPSS_CELLTYPE CellType,
'                                     long Style, LPSS_DATEFORMAT lpFormat,
'                                     LPSS_DATE lpMin, LPSS_DATE lpMax);

DECLARE _
  FUNCTION _
    SSSetTypeDate LIB "SPR32D30.DLL" ALIAS "SSSetTypeDate" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
            lpFormat        AS tagSS_DATEFORMAT,_
            lpMin           AS tagSS_DATE,_
            lpMax           AS tagSS_DATE _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeEdit(HWND hWnd, LPSS_CELLTYPE CellType,
'                                     long Style, int Len,
'                                     short ChrSet, short ChrCase);

DECLARE _
  FUNCTION _
    SSSetTypeEdit LIB "SPR32D30.DLL" ALIAS "SSSetTypeEdit" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
      BYVAL lLen            AS LONG,_
      BYVAL ChrSet          AS INTEGER,_
      BYVAL ChrCase         AS INTEGER _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeFloat(HWND hWnd, LPSS_CELLTYPE CellType,
'                                      long Style, short Left, short Right,
'                                      double Min, double Max);

DECLARE _
  FUNCTION _
    SSSetTypeFloat LIB "SPR32D30.DLL" ALIAS "SSSetTypeFloat" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
      BYVAL xLeft           AS INTEGER,_
      BYVAL xRight          AS INTEGER,_
      BYVAL xMin            AS DOUBLE,_
      BYVAL xMax            AS DOUBLE _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeFloatExt(HWND hWnd, LPSS_CELLTYPE CellType,
'                                         long Style, short Left, short Right,
'                                         double Min, double Max,
'                                         LPSS_FLOATFORMAT lpFormat);

DECLARE _
  FUNCTION _
    SSSetTypeFloatExt LIB "SPR32D30.DLL" ALIAS "SSSetTypeFloatExt" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
      BYVAL xLeft           AS INTEGER,_
      BYVAL xRight          AS INTEGER,_
      BYVAL xMin            AS DOUBLE,_
      BYVAL xMax            AS DOUBLE,_
            lpFormat        AS tagSS_FLOATFORMAT _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeInteger(HWND hWnd, LPSS_CELLTYPE CellType,
'                                        long Min, long Max);

DECLARE _
  FUNCTION _
    SSSetTypeInteger LIB "SPR32D30.DLL" ALIAS "SSSetTypeInteger" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL lMin            AS LONG,_
      BYVAL lMax            AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeIntegerExt(HWND hWnd, LPSS_CELLTYPE CellType,
'                                           long lStyle, long lMin, long lMax,
'                                           BOOL fSpinWrap, long lSpinInc);

DECLARE _
  FUNCTION _
    SSSetTypeIntegerExt LIB "SPR32D30.DLL" ALIAS "SSSetTypeIntegerExt" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
      BYVAL lMin            AS LONG,_
      BYVAL lMax            AS LONG,_
      BYVAL fSpinWrap       AS LONG,_
      BYVAL lSpinInc        AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeOwnerDraw(HWND hWnd, LPSS_CELLTYPE lpCellType,
'                                          long lStyle);

DECLARE _
  FUNCTION _
    SSSetTypeOwnerDraw LIB "SPR32D30.DLL" ALIAS "SSSetTypeOwnerDraw" ( _
      BYVAL hWnd            AS DWORD,_
            lpCellType      AS SS_CELLTYPE,_
      BYVAL Style           AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypePic(HWND hWnd, LPSS_CELLTYPE CellType,
'                                    long Style, LPCTSTR Mask);

DECLARE _
  FUNCTION _
    SSSetTypePic LIB "SPR32D30.DLL" ALIAS "SSSetTypePic" ( _
      BYVAL hWnd            AS DWORD,_
            lpCellType      AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
            lpszMask        AS ASCIIZ _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypePicture(HWND hWnd, LPSS_CELLTYPE CellType,
'                                        long Style, LPCTSTR PictName);

DECLARE _
  FUNCTION _
    SSSetTypePicture LIB "SPR32D30.DLL" ALIAS "SSSetTypePicture" ( _
      BYVAL hWnd            AS DWORD,_
            lpCellType      AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
            PictName        AS ASCIIZ _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypePictureHandle(HWND hWnd,
'                                              LPSS_CELLTYPE CellType,
'                                              long Style, HANDLE hPict,
'                                              HPALETTE hPal,
'                                              BOOL fDeleteHandle);

DECLARE _
  FUNCTION _
    SSSetTypePictureHandle LIB "SPR32D30.DLL" ALIAS "SSSetTypePictureHandle" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
      BYVAL hPict           AS DWORD,_
      BYVAL hPal            AS DWORD,_
      BYVAL fDeleteHandle   AS LONG _
    ) AS DWORD
_'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeStaticText(HWND hWnd, LPSS_CELLTYPE CellType,
'                                           long TextStyle);

DECLARE _
  FUNCTION _
    SSSetTypeStaticText LIB "SPR32D30.DLL" ALIAS "SSSetTypeStaticText" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL TextStype       AS LONG _
    ) AS DWORD
'---------------------------------------------------------------------------
'LPSS_CELLTYPE DLLENTRY SSSetTypeTime(HWND hWnd, LPSS_CELLTYPE CellType,
'                                     long Style, LPSS_TIMEFORMAT lpFormat,
'                                     LPSS_TIME lpMin, LPSS_TIME lpMax);

DECLARE _
  FUNCTION _
    SSSetTypeTime LIB "SPR32D30.DLL" ALIAS "SSSetTypeTime" ( _
      BYVAL hWnd            AS DWORD,_
            CellType        AS SS_CELLTYPE,_
      BYVAL Style           AS LONG,_
            lpFormat        AS tagSS_TIMEFORMAT,_
            lpMin           AS tagSS_TIME,_
            lpMax           AS tagSS_TIME _
    ) AS DWORD
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetUnitType(HWND hWnd, WORD wUnitType);

DECLARE _
  FUNCTION _
    SSSetUnitType LIB "SPR32D30.DLL" ALIAS "SSSetUnitType" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL uUnitType       AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'LONG DLLENTRY SSSetUserData(HWND hWnd, LONG lUserData);

DECLARE _
  FUNCTION _
    SSSetUserData LIB "SPR32D30.DLL" ALIAS "SSSetUserData" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL lUserData       AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'WORD DLLENTRY SSSetUserResize(HWND hWnd, WORD wUserResize);

DECLARE _
  FUNCTION _
    SSSetUserResize LIB "SPR32D30.DLL" ALIAS "SSSetUserResize" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL wUserResize     AS CWORD _
    ) AS CWORD
'---------------------------------------------------------------------------
'short DLLENTRY SSSetUserResizeCol(HWND hWnd, SS_COORD Col, short dOption);

DECLARE _
  FUNCTION _
    SSSetUserResizeCol LIB "SPR32D30.DLL" ALIAS "SSSetUserResizeCol" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL dOption         AS INTEGER _
    ) AS INTEGER
'---------------------------------------------------------------------------
'short DLLENTRY SSSetUserResizeRow(HWND hWnd, SS_COORD Row, short dOption);

DECLARE _
  FUNCTION _
    SSSetUserResizeRow LIB "SPR32D30.DLL" ALIAS "SSSetUserResizeRow" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL dOption         AS INTEGER _
    ) AS INTEGER
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetValue(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                         LPCTSTR lpData);

DECLARE _
  FUNCTION _
    SSSetValue LIB "SPR32D30.DLL" ALIAS "SSSetValue" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
            lpData          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetValueRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                              SS_COORD Col2, SS_COORD Row2, LPCTSTR lpData);

DECLARE _
  FUNCTION _
    SSSetValueRange LIB "SPR32D30.DLL" ALIAS "SSSetValueRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
            lpData          AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSShowActiveCell(HWND hwnd, short Position);

DECLARE _
  FUNCTION _
    SSShowActiveCell LIB "SPR32D30.DLL" ALIAS "SSShowActiveCell" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL iPosition       AS INTEGER _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSShowCell(HWND hwnd, SS_COORD Col, SS_COORD Row,
'                         short Position);

DECLARE _
  FUNCTION _
    SSShowCell LIB "SPR32D30.DLL" ALIAS "SSShowCell" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL iPosition       AS INTEGER _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSShowCol(HWND hWnd, SS_COORD Col, BOOL fShow);

DECLARE _
  FUNCTION _
    SSShowCol LIB "SPR32D30.DLL" ALIAS "SSShowCol" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL fShow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSShowRow(HWND hWnd, SS_COORD Row, BOOL fShow);

DECLARE _
  FUNCTION _
    SSShowRow LIB "SPR32D30.DLL" ALIAS "SSShowRow" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Row             AS LONG,_
      BYVAL fShow           AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSort(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                     SS_COORD Col2, SS_COORD Row2, LPSS_SORT lpSort);

DECLARE _
  FUNCTION _
    SSSort LIB "SPR32D30.DLL" ALIAS "SSSort" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
            lpSort          AS SS_SORT _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSwapRange(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                          SS_COORD Col2, SS_COORD Row2,
'                          SS_COORD ColDest, SS_COORD RowDest);

DECLARE _
  FUNCTION _
    SSSwapRange LIB "SPR32D30.DLL" ALIAS "SSSwapRange" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL Col             AS LONG,_
      BYVAL Row             AS LONG,_
      BYVAL Col2            AS LONG,_
      BYVAL Row2            AS LONG,_
      BYVAL ColDest         AS LONG,_
      BYVAL RowDest         AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSValidateFormula(HWND hWnd, LPCTSTR lpszFormula);

DECLARE _
  FUNCTION _
    SSValidateFormula LIB "SPR32D30.DLL" ALIAS "SSValidateFormula" ( _
      BYVAL hWnd            AS DWORD,_
            lpszFormula     AS ASCIIZ _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSVGetBufferSize(HWND hWnd, LPSS_COORD lpdBufferSize,
'                               LPSS_COORD lpdOverlap);

DECLARE _
  SUB _
    SSVGetBufferSize LIB "SPR32D30.DLL" ALIAS "SSVGetBufferSize" ( _
      BYVAL hWnd            AS DWORD,_
            lpdBufferSize   AS LONG,_
            lpdOverlap      AS LONG _
    )
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSVGetMax(HWND hWnd);

DECLARE _
  FUNCTION _
    SSVGetMax LIB "SPR32D30.DLL" ALIAS "SSVGetMax" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSVGetPhysBufferSize(HWND hWnd);

DECLARE _
  FUNCTION _
    SSVGetPhysBufferSize LIB "SPR32D30.DLL" ALIAS "SSVGetPhysBufferSize" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSVGetPhysBufferTop(HWND hWnd);

DECLARE _
  FUNCTION _
    SSVGetPhysBufferTop LIB "SPR32D30.DLL" ALIAS "SSVGetPhysBufferTop" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'LONG DLLENTRY SSVGetStyle(HWND hWnd);

DECLARE _
  FUNCTION _
    SSVGetStyle LIB "SPR32D30.DLL" ALIAS "SSVGetStyle" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSVRefreshBuffer(HWND hWnd);

DECLARE _
  FUNCTION _
    SSVRefreshBuffer LIB "SPR32D30.DLL" ALIAS "SSVRefreshBuffer" ( _
      BYVAL hWnd            AS DWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSVScrollGetSpecial(HWND hWnd, LPWORD lpwOptions);

DECLARE _
  FUNCTION _
    SSVScrollGetSpecial LIB "SPR32D30.DLL" ALIAS "SSVScrollGetSpecial" ( _
      BYVAL hWnd            AS DWORD,_
            lpwOptions      AS CWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSVScrollSetSpecial(HWND hWnd, BOOL fUseSpecialVScroll,
'                                  WORD wOptions);

DECLARE _
  FUNCTION _
    SSVScrollSetSpecial LIB "SPR32D30.DLL" ALIAS "SSVScrollSetSpecial" ( _
      BYVAL hWnd                AS DWORD,_
      BYVAL fUseSpecialVScroll  AS LONG,_
      BYVAL wOptions            AS CWORD _
    ) AS LONG
'---------------------------------------------------------------------------
'void DLLENTRY SSVSetBufferSize(HWND hWnd, SS_COORD dBufferSize,
'                               SS_COORD dOverlap);

DECLARE _
  SUB _
    SSVSetBufferSize LIB "SPR32D30.DLL" ALIAS "SSVSetBufferSize" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL dBufferSize     AS LONG,_
      BYVAL dOverlap        AS LONG _
    )
'---------------------------------------------------------------------------
'SS_COORD DLLENTRY SSVSetMax(HWND hWnd, SS_COORD Max);

DECLARE _
  FUNCTION _
    SSVSetMax LIB "SPR32D30.DLL" ALIAS "SSVSetMax" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL xMax            AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'LONG DLLENTRY SSVSetStyle(HWND hWnd, LONG lStyle);

DECLARE _
  FUNCTION _
    SSVSetStyle LIB "SPR32D30.DLL" ALIAS "SSVSetStyle" ( _
      BYVAL hWnd            AS DWORD,_
      BYVAL lStyle          AS LONG _
    ) AS LONG
'---------------------------------------------------------------------------
'BOOL DLLENTRY SSSetActionKey(HWND hWnd, WORD wAction, BOOL fShift,
'							 BOOL fCtrl, WORD wKey);
DECLARE _
  FUNCTION _
    SSSetActionKey LIB "SPR32D30.DLL" ALIAS "SSSetActionKey" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL wAction			AS CWORD, _
		BYVAL fShift			AS LONG, _
		BYVAL fCtrl				AS LONG, _
		BYVAL wKey				AS CWORD _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetActionKey(HWND hWnd, WORD wAction, LPBOOL lpfShift,
'							 LPBOOL lpfCtrl, LPWORD lpwKey);
DECLARE _
  FUNCTION _
    SSGetActionKey LIB "SPR32D30.DLL" ALIAS "SSGetActionKey" ( _
	   byval hWnd				AS DWORD, _
		BYVAL wAction			AS CWORD, _
		      lpfShift			AS LONG, _
				lpfCtrl			AS LONG, _
				lpwKey			AS CWORD _
	) AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSSetOddEvenRowColor(HWND hWnd, COLORREF clrBackOdd,
'								   COLORREF clrForeOdd,
'								   COLORREF clrBackEven,
'								   COLORREF clrForeEven);
DECLARE _
  FUNCTION _
    SSSetOddEvenRowColor LIB "SPR32D30.DLL" ALIAS "SSSetOddEvenRowColor" ( _
	   byval hWnd				AS DWORD, _
		BYVAL clrBackOdd		AS LONG, _
		BYVAL clrForeOdd		AS LONG, _
		BYVAL clrBackEven		AS LONG, _
		BYVAL clrForeEven		AS LONG _
	)AS LONG
'------------------------------------------------------------------------------

'BOOL DLLENTRY SSGetOddEvenRowColor(HWND hWnd, LPCOLORREF lpclrBackOdd,
'								   LPCOLORREF lpclrForeOdd,
'								   LPCOLORREF lpclrBackEven,
'								   LPCOLORREF lpclrForeEven);
DECLARE _
  FUNCTION _
    SSGetOddEvenRowColor LIB "SPR32D30.DLL" ALIAS "SSGetOddEvenRowColor" ( _
	   BYVAL hWnd					AS DWORD, _
	         lpclrBackOdd		AS LONG, _
            lpclrForeOdd		AS LONG, _
		      lpclrBackEven		AS LONG, _
		      lpclrForeEven 	AS LONG _
	) as long
'------------------------------------------------------------------------------
'WORD DLLENTRY SSSetAppearance(HWND hWnd, WORD wAppearance);
DECLARE _
  FUNCTION _
    SSSetAppearance LIB "SPR32D30.DLL" ALIAS "SSSetAppearance" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL wAppearance		AS CWORD _
	)AS CWORD
'------------------------------------------------------------------------------
'WORD DLLENTRY SSGetAppearance(HWND hWnd);
DECLARE _
  FUNCTION _
    SSGetAppearance LIB "SPR32D30.DLL" ALIAS "SSGetAppearance" ( _
	   BYVAL hWnd				AS DWORD _
	) AS CWORD
'------------------------------------------------------------------------------
'void DLLENTRY SSSetCalText(LPCTSTR lpszShortDays, LPCTSTR lpszLongDays,
'                           LPCTSTR lpszShortMonths, LPCTSTR lpszLongMonths,
'                           LPCTSTR lpszOkText, LPCTSTR lpszCancelText);
DECLARE _
  SUB _
	 SSSetCalText LIB "SPR32D30.DLL" ALIAS "SSSetCalText" ( _
				lpszShortDays			AS ASCIIZ, _
		      lpszLongDays			AS ASCIIZ, _
		      lpszShortMonths		AS ASCIIZ, _
		      lpszLongMonths			AS ASCIIZ, _
				lpszOkText				AS ASCIIZ, _
				lpszCancelText			as asciiz _
	)
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetBorderEx(HWND hWnd, SS_COORD Col, SS_COORD Row,
'                            LPWORD lpwStyleLeft, LPCOLORREF lpclrLeft,
'                            LPWORD lpwStyleTop, LPCOLORREF lpclrTop,
'                            LPWORD lpwStyleRight, LPCOLORREF lpclrRight,
'                            LPWORD lpwStyleBottom, LPCOLORREF lpclrBottom);
DECLARE _
  FUNCTION _
    SSGetBorderEx LIB "SPR32D30.DLL" ALIAS "SSGetBorderEx" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL Col				AS LONG, _
		BYVAL Row				AS LONG, _
            lpwStyleLeft	AS CWORD, _
				lpclrLeft		AS LONG, _
				lpwStyleTop		AS CWORD, _
				lpclrTop			AS LONG, _
				lpwStyleRight	AS CWORD, _
				lpclrRight		AS LONG, _
				lpwStyleBottom	AS CWORD, _
				lpclrBottom		AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'WORD DLLENTRY SSSetClipboardOptions(HWND hWnd, WORD wOptions);
DECLARE _
  FUNCTION _
    SSSetClipboardOptions LIB "SPR32D30.DLL" ALIAS "SSSetClipboardOptions" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL wOptions			AS CWORD _
	)AS CWORD
'------------------------------------------------------------------------------
'WORD DLLENTRY SSGetClipboardOptions(HWND hWnd);
DECLARE _
  FUNCTION _
    SSGetClipboardOptions LIB "SPR32D30.DLL" ALIAS "SSGetClipboardOptions" ( _
	   BYVAL hWnd				AS DWORD _
	)AS CWORD
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSIsRowHidden(HWND hWnd, SS_COORD Row);
DECLARE _
  FUNCTION _
    SSIsRowHidden LIB "SPR32D30.DLL" ALIAS "SSIsRowHidden" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL Row				AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSIsColHidden(HWND hWnd, SS_COORD Col);
DECLARE _
  FUNCTION _
    SSIsColHidden LIB "SPR32D30.DLL" ALIAS "SSIsColHidden" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL Col				AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'void DLLENTRY SSSetPrintOptions(HWND hWnd, LPSS_PRINTFORMAT lpPrintFormat,
'                                SS_PRINTFUNC lpfnPrintProc, LONG lAppData);
DECLARE _
  SUB _
    SSSetPrintOptions LIB "SPR32D30.DLL" ALIAS "SSSetPrintOptions" ( _
		 BYVAL hWnd				AS DWORD, _
		 BYVAL lpPrintFormat	AS SS_PRINTFORMAT PTR, _
		 BYVAL lpfnPrintProc	AS DWORD, _
		 BYVAL lAppData		AS LONG _
    )
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetPrintOptions(HWND hWnd, LPSS_PRINTFORMAT lpPrintFormat,
'                                SS_PRINTFUNC FAR *lpfnPrintProcAddr,
'                                LPLONG lplAppData);
DECLARE _
  FUNCTION _
    SSGetPrintOptions LIB "SPR32D30.DLL" ALIAS "SSGetPrintOptions" ( _
	   BYVAL hWnd					AS DWORD, _
		BYVAL lpPrintFormat		AS SS_PRINTFORMAT PTR, _
		      lpfnPrintProcAddr AS DWORD, _
				lplAppData			AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'long DLLENTRY SSGetPrintPageCount(HWND hWnd);
DECLARE _
  FUNCTION _
    SSGetPrintPageCount LIB "SPR32D30.DLL" ALIAS "SSGetPrintPageCount" ( _
	   byval hWnd				AS DWORD _
	 )AS LONG
'------------------------------------------------------------------------------
'long DLLENTRY SSGetNextPageBreakCol(HWND hWnd, long lPrevCol);
DECLARE _
  FUNCTION _
    SSGetNextPageBreakCol LIB "SPR32D30.DLL" ALIAS "SSGetNextPageBreakCol" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lPrevCol			AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'long DLLENTRY SSGetNextPageBreakRow(HWND hWnd, long lPrevRow);
DECLARE _
  FUNCTION _
    SSGetNextPageBreakRow LIB "SPR32D30.DLL" ALIAS "SSGetNextPageBreakRow" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lPrevRow			AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'void DLLENTRY SSGetSelColor(HWND hWnd, LPCOLORREF lpclrBack, LPCOLORREF lpclrFore);
DECLARE _
  SUB _
    SSGetSelColor LIB "SPR32D30.DLL" ALIAS "SSGetSelColor"( _
	   BYVAL hWnd				AS DWORD, _
		      lpclrBack		AS LONG, _
				lpclrFore		AS LONG _
	)
'------------------------------------------------------------------------------
'void DLLENTRY SSSetSelColor(HWND hWnd, COLORREF clrBack, COLORREF clrFore);
DECLARE _
  SUB _
    SSSetSelColor LIB "SPR32D30.DLL" ALIAS "SSSetSelColor" ( _
	   BYVAl hWnd				AS DWORD, _
		BYVAL clrBack			AS LONG, _
		BYVAL clrFore			AS LONG _
	)
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSSetArray(HWND hWnd, LPVOID lpArray, SS_COORD ColLeft,
'                         SS_COORD RowTop, SS_COORD ArrayColCnt,
'                         SS_COORD ArrayRowCnt, WORD wDataType);
DECLARE _
  FUNCTION _
    SSSetArray LIB "SPR32D30.DLL" ALIAS "SSSetArray" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lpArray			AS DWORD, _
		BYVAL ColLeft			AS LONG, _
		BYVAL RowTop			AS LONG, _
		BYVAL ArrayColCnt		AS LONG, _
		BYVAl ArrayRowCnt		AS LONG,_
		BYVAL wDataType		AS CWORD _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetArray(HWND hWnd, LPVOID lpArray, SS_COORD ColLeft,
'                         SS_COORD RowTop, SS_COORD ArrayColCnt,
'                         SS_COORD ArrayRowCnt, WORD wDataType);
DECLARE _
  FUNCTION _
    SSGetArray LIB "SPR32D30.DLL" ALIAS "SSGetArray" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lpArray			AS DWORD, _
	   BYVAL hWnd				AS DWORD, _
		BYVAL lpArray			AS DWORD, _
		BYVAL ColLeft			AS LONG, _
		BYVAL RowTop			AS LONG, _
		BYVAL ArrayColCnt		AS LONG, _
		BYVAl ArrayRowCnt		AS LONG,_
		BYVAL wDataType		AS CWORD _
	)AS LONG
'------------------------------------------------------------------------------
'short DLLENTRY SSGetTwoDigitYearMax(HWND hWnd);
DECLARE _
  FUNCTION _
    SSGetTwoDigitYearMax LIB "SPR32D30.DLL" ALIAS "SSGetTwoDigitYearMax" ( _
	   BYVAL hWnd				AS DWORD _
	)AS INTEGER
'------------------------------------------------------------------------------
'BOOL DLLENTRY  SSSetTwoDigitYearMax(HWND hWnd, short nTwoDigitYearMax);
DECLARE _
  FUNCTION _
    SSSetTwoDigitYearMax LIB "SPR32D30.DLL" ALIAS "SSSetTwoDigitYearMax" ( _
	   BYVAL hWnd					AS DWORD, _
		BYVAL nTwoDigitYearMax	AS INTEGER _
	) AS LONG
'------------------------------------------------------------------------------
%SS_ARRAYTYPE_SHORT  = 0
%SS_ARRAYTYPE_LONG   = 1
%SS_ARRAYTYPE_FLOAT  = 2
%SS_ARRAYTYPE_DOUBLE = 3
%SS_ARRAYTYPE_INT    = 4
'------------------------------------------------------------------------------
'/***************************
'* Support for the Text Tip
'***************************/

'BOOL DLLENTRY SSSetTextTip(HWND hWnd, WORD wStatus, LONG lDelay,
'                           LPLOGFONT lpLogFont, COLORREF clrBack,
'                           COLORREF clrFore);
DECLARE _
  FUNCTION _
    SSSetTextTip LIB "SPR32D30.DLL" ALIAS "SSSetTextTip" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL wStatus			AS CWORD, _
		BYVAL lDelay			AS LONG, _
		BYVAL lpLogFont		AS DWORD, _
		BYVAL clrBack			AS LONG, _
		BYVAL clrFore			AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetTextTip(HWND hWnd, LPWORD lpwStatus, LPLONG lplDelay,
'                           LPLOGFONT lpLogFont, LPCOLORREF lpclrBack,
'                           LPCOLORREF lpclrFore);
DECLARE _
  FUNCTION _
    SSGetTextTip LIB "SPR32D30.DLL" ALIAS "SSGetTextTip" ( _
	   BYVAL hWnd				AS DWORD, _
		      lpwStatus		AS CWORD, _
				lpDelay			AS LONG, _
      BYVAL	lpLongFont		AS LOGFONT PTR, _
		      lpclrBack		AS LONG, _
				lpclrFore		AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
%SS_TT_STATUS_OFF               = 0
%SS_TT_STATUS_FIXED             = 1
%SS_TT_STATUS_FLOATING          = 2
%SS_TT_STATUS_FIXEDFOCUSONLY    = 3
%SS_TT_STATUS_FLOATINGFOCUSONLY = 4

%SS_TT_XALIGN_AUTO   = 0
%SS_TT_XALIGN_LEFT   = 1
%SS_TT_XALIGN_RIGHT  = 2
%SS_TT_XALIGN_CENTER = 3

%SS_TT_YALIGN_AUTO   = 0
%SS_TT_YALIGN_TOP    = 1
%SS_TT_YALIGN_BOTTOM = 2
%SS_TT_YALIGN_CENTER = 3

%SS_TT_MULTILINE_SINGLE = 0
%SS_TT_MULTILINE_MULTI  = 1
%SS_TT_MULTILINE_AUTO   = 2

%SS_TT_TEXTMAX        = 1024

'typedef struct ss_texttipfetch
'   {
'   BOOL     fShow;
'   WORD     wMultiLine;
'   WORD     wAlignX;
'   WORD     wAlignY;
'   short    xOffset;
'   short    yOffset;
'   short    nWidth;
'   SS_COORD Col;
'   SS_COORD Row;
'   char     szText[SS_TT_TEXTMAX + 1];
'   } SS_TEXTTIPFETCH, FAR *LPSS_TEXTTIPFETCH;

TYPE ss_texttipfetch
    fShow			as long
    wMultiLine		AS CWORD
    wAlignX			AS CWORD
    wAlignY			AS CWORD
    xOffset			AS INTEGER
    yOffset			AS INTEGER
    nWidth			AS INTEGER
    Col				AS LONG
    Row				AS LONG
    szText			as asciiz * (%SS_TT_TEXTMAX + 1)
END TYPE

'/*******************************************
'* Support for HTML File Export (32-bit only)
'*******************************************/
'BOOL DLLENTRY SSExportToHTML (HWND hWnd, LPCTSTR lpszFileName,
'							  BOOL bAppendFlag, LPCTSTR lpszLogFile);
DECLARE _
  FUNCTION _
    SSExportToHTML LIB "SPR32D30.DLL" ALIAS "SSExportToHTML" ( _
	   BYVAL hWnd				AS DWORD, _
		      lpszFileName	AS ASCIIZ, _
		BYVAL bAppendFlag		AS LONG, _
		      lpszLogFile		AS ASCIIZ _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSExportRangeToHTML (HWND hWnd, SS_COORD col,
'								   SS_COORD row, SS_COORD col2, SS_COORD row2,
'								   LPCTSTR lpszFileName, BOOL bAppendFlag,
'								   LPCTSTR lpszLogFile);
DECLARE _
  FUNCTION _
    SSExportRangeToHTML LIB "SPR32D30.DLL" ALIAS "SSExportRangeToHTML" ( _
	   BYVAL hWnd				AS DWORD, _
		BYVAL col				AS LONG, _
		BYVAL row				AS LONG, _
		BYVAL col2				AS LONG, _
		BYVAL row2				AS LONG, _
		      lpszFileName	AS ASCIIZ, _
		BYVAL bAppendFlag		AS LONG, _
		     lpszLogFile		AS ASCIIZ _
	)AS LONG
'------------------------------------------------------------------------------
'/************************************************
'* Support for Excel File Conversion (32-bit Only)
'************************************************/
'BOOL DLLENTRY SSIsExcelFile(LPCTSTR lpszFileName);
DECLARE _
  FUNCTION _
    SSIsExcelFile LIB "SPR32D30.DLL" ALIAS "SSIsExcelFile" ( _
	         lpszFileName	AS ASCIIZ _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSGetExcelSheetList(HWND hWnd, LPCTSTR lpszFileName,
'								  GLOBALHANDLE FAR *lpghList, LPSHORT lpnListCount,
'								  LPCTSTR lpszLogFileName, LPSHORT lpnWorkbookHandle,
'								  BOOL fReplace);
DECLARE _
  FUNCTION _
    SSGetExcelSheetList LIB "SPR32D30.DLL" ALIAS "SSGetExcelSheetList" ( _
		BYVAL	hWnd				AS DWORD, _
				lpszFileName		AS ASCIIZ, _
				lpghList			AS DWORD, _
				lpnListCount		AS LONG, _
				lpszLogFileName		AS ASCIIZ, _
				lpnWorkBookHandle	AS INTEGER, _
		BYVAL 	fReplace			AS LONG _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSImportExcelSheet(HWND hWnd, short nWorkbookHandle, short nSheetIndex,
'								 LPCTSTR lpszSheetName);
DECLARE _
  FUNCTION _
    SSImportExcelSheet LIB "SPR32D30.DLL" ALIAS "SSImportExcelSheet" ( _
	   BYVAL hWnd					AS DWORD, _
		BYVAL nWorkbookHandle	AS INTEGER, _
		BYVAL nSheetIndex			AS INTEGER, _
		      lpszSheetName		AS ASCIIZ _
	)AS LONG
'------------------------------------------------------------------------------
'BOOL DLLENTRY SSExportToExcel(HWND hWnd, LPCTSTR lpszFileName, LPCTSTR lpszSheetName,
'								LPCTSTR lpszLogFileName);
DECLARE _
  FUNCTION _
    SSExportToExcel LIB "SPR32D30.DLL" ALIAS "SSExportToExcel" ( _
	   byval hWnd					AS DWORD, _
		      lpszFileName		AS ASCIIZ, _
				lpszSheetName		AS ASCIIZ, _
				lpszLogFileName	AS ASCIIZ _
	)AS LONG
'------------------------------------------------------------------------------



'------------------------------------------------------------------------------
'////////////
'//HERE
'///////////

'//--------------------------------------------------------------------
'//
'//  Contants used by spreadsheet functions.
'//

'// Limit on column and/or row index parameter
'#ifdef SS_USE16BITCOORDS
'%SS_MAXCOORD            =32000
'#else
%SS_MAXCOORD            =2000000000&
'#endif

'// Column and/or row index parameter
%SS_ALLCOLS             =-1
%SS_ALLROWS             =-1
%SS_FIRST               =-1
%SS_LAST                =-2
%SS_HEADER              =-32767

'// Parameter count used by SSAddCustomFunction
%SS_CALC_MAXPARAMS      =30
%SS_CALC_VARPARAMS      =-1

'// Custom function flags used by SSAddCustomFunctionExt
%SS_CUSTFUNC_WANTCELLREF  =1
%SS_CUSTFUNC_WANTRANGEREF =2

'// Back color styles used by SSSetBackColorStyle
%SS_BACKCOLORSTYLE_OVERGRID         =0
%SS_BACKCOLORSTYLE_UNDERGRID        =1
%SS_BACKCOLORSTYLE_OVERHORZGRIDONLY =2
%SS_BACKCOLORSTYLE_OVERVERTGRIDONLY =3

'// Booleans used by SSSetBool
%SSB_PROTECT            =0
%SSB_RESTRICTROWS       =1
%SSB_RESTRICTCOLS       =2
%SSB_SHOWCOLHEADERS     =3
%SSB_SHOWROWHEADERS     =4
%SSB_ALLOWUSERRESIZE    =5
%SSB_ALLOWUSERSELBLOCK  =6
%SSB_AUTOCALC           =7
%SSB_REDRAW             =8
%SSB_GRIDLINES          =9
%SSB_HORZSCROLLBAR      =10
%SSB_VERTSCROLLBAR      =11
%SSB_ALLOWUSERFORMULAS  =12
%SSB_EDITMODEPERMANENT  =13
%SSB_AUTOSIZE           =14
%SSB_SCROLLBAREXTMODE   =15
%SSB_SCROLLBARSHOWMAX   =16
%SSB_SCROLLBARMAXALIGN  =17
%SSB_PROCESSTAB         =18
%SSB_ARROWSEXITEDITMODE =19
%SSB_MOVEACTIVEONFOCUS  =20
%SSB_RETAINSELBLOCK     =21
%SSB_EDITMODEREPLACE    =22
%SSB_NOBORDER           =23
%SSB_NOBEEP             =24
%SSB_AUTOCLIPBOARD      =25
%SSB_ALLOWMULTIBLOCKS   =26
%SSB_ALLOWCELLOVERFLOW  =27
%SSB_VIRTUALMODE        =28
%SSB_ALLOWDRAGDROP      =29
%SSB_CHANGEMADE         =30
%SSB_FORMULASYNC        =31
%SSB_HSCROLLBARTRACK    = 32
%SSB_VSCROLLBARTRACK    = 33

'// Border types used by SSSetBorder
%SS_BORDERTYPE_NONE         = &H00
%SS_BORDERTYPE_LEFT         = &H01
%SS_BORDERTYPE_RIGHT        = &H02
%SS_BORDERTYPE_TOP          = &H04
%SS_BORDERTYPE_BOTTOM       = &H08
%SS_BORDERTYPE_OUTLINE      = &H10

'// Border styles used by SSSetBorder
%SS_BORDERSTYLE_NONE              =0
%SS_BORDERSTYLE_SOLID             =1
%SS_BORDERSTYLE_DASH              =2
%SS_BORDERSTYLE_DOT               =3
%SS_BORDERSTYLE_DASHDOT           =4
%SS_BORDERSTYLE_DASHDOTDOT        =5
%SS_BORDERSTYLE_BLANK             =6
'//- Adds more border styles (Masanori Iwasa)
%SS_BORDERSTYLE_FINE_SOLID        =11
%SS_BORDERSTYLE_FINE_DASH         =12
%SS_BORDERSTYLE_FINE_DOT          =13
%SS_BORDERSTYLE_FINE_DASH_DOT     =14
%SS_BORDERSTYLE_FINE_DASH_DOT_DOT =15

'// Button draw modes used by SSSetButtonDrawMode
%SS_BDM_ALWAYS          = &H00
%SS_BDM_CURRENTCELL     = &H01
%SS_BDM_CURRENTCOL      = &H02
%SS_BDM_CURRENTROW      = &H04
%SS_BDM_ALWAYSBUTTON    = &H08
%SS_BDM_ALWAYSCOMBO     = &H10

'// Colors used by SSSetColor
'#if defined(SS_OCX) || defined(SS_VB)
'%RGBCOLOR_DEFAULT     (&H80000000& OR %COLOR_INACTIVEBORDER)
'#else
'#ifdef RGBCOLOR_DEFAULT
'#undef RGBCOLOR_DEFAULT
'#endif
%RGBCOLOR_DEFAULT   = -1&
'#endif
%RGBCOLOR_WHITE = 16777215
%RGBCOLOR_BLUE = 16711680
%RGBCOLOR_RED = 255
%RGBCOLOR_PINK = 16711935
%RGBCOLOR_GREEN = 65280
%RGBCOLOR_CYAN = 16776960
%RGBCOLOR_YELLOW = 65535
%RGBCOLOR_BLACK = 0
%RGBCOLOR_DARKGRAY = 8421504
%RGBCOLOR_DARKBLUE = 8388608
%RGBCOLOR_DARKRED = 128
%RGBCOLOR_DARKPINK = 8388863
%RGBCOLOR_DARKGREEN = 32768
%RGBCOLOR_DARKCYAN = 8421376
%RGBCOLOR_BROWN = 4227200
%RGBCOLOR_PALEGRAY = 12632256

'// Column and row header options used by SSSetColHeaderDisplay
'// and SSSetRowHeaderDisplay
%SS_HEADERDISPLAY_BLANK   =0
%SS_HEADERDISPLAY_NUMBERS =1
%SS_HEADERDISPLAY_LETTERS =2

'// Cursor types used by SSSetCursor
%SS_CURSORTYPE_DEFAULT    = &H01
%SS_CURSORTYPE_COLRESIZE  = &H02
%SS_CURSORTYPE_ROWRESIZE  = &H04
%SS_CURSORTYPE_BUTTON     = &H08
%SS_CURSORTYPE_GRAYAREA   = &H10
%SS_CURSORTYPE_LOCKEDCELL = &H20
%SS_CURSORTYPE_COLHEADER  = &H40
%SS_CURSORTYPE_ROWHEADER  = &H80
%SS_CURSORTYPE_DRAGDROPAREA = &H0100
%SS_CURSORTYPE_DRAGDROP     = &H0200

'// Cursors used by SSSetCursor
%SS_CURSOR_DEFAULT        = 0
%SS_CURSOR_ARROW          = -1
%SS_CURSOR_DEFCOLRESIZE   = -2
%SS_CURSOR_DEFROWRESIZE   = -3

'// Edit ENTER key actions used by SSSetEditEnterAction
%SS_ENTERACTION_NONE    =0
%SS_ENTERACTION_UP      =1
%SS_ENTERACTION_DOWN    =2
%SS_ENTERACTION_LEFT    =3
%SS_ENTERACTION_RIGHT   =4
%SS_ENTERACTION_NEXT    =5
%SS_ENTERACTION_PREV    =6
%SS_ENTERACTION_SAME    =7
%SS_ENTERACTION_NEXTROW =8

'// Grid types used by SSSetGridType
%SS_GRID_HORIZONTAL     = &H01
%SS_GRID_VERTICAL       = &H02
%SS_GRID_SOLID          = &H04

'// Operation modes used by SSSetOperationMode
%SS_OPMODE_NORMAL       =0
%SS_OPMODE_READONLY     =1
%SS_OPMODE_ROWMODE      =2
%SS_OPMODE_SINGLESEL    =3
%SS_OPMODE_MULTISEL     =4
%SS_OPMODE_EXTSEL       =5

'// Reference styles used by SSSetRefStyle
%SS_REFSTYLE_DEFAULT =0
%SS_REFSTYLE_A1      =1
%SS_REFSTYLE_R1C1    =2

'// Select block options used by SSSetSelBlockOptions
%SS_SELBLOCK_COLS           = &H01
%SS_SELBLOCK_ROWS           = &H02
%SS_SELBLOCK_BLOCKS         = &H04
%SS_SELBLOCK_ALL            = &H08

'// Select mode messages used by SSSelModeSendMessage
%SS_SELMODE_CLEARSEL     =1
%SS_SELMODE_GETCURSEL    =2
%SS_SELMODE_GETSEL       =3
%SS_SELMODE_GETSELCOUNT  =4
%SS_SELMODE_GETSELITEMS  =5
%SS_SELMODE_SELITEMRANGE =6
%SS_SELMODE_SETCURSEL    =7
%SS_SELMODE_SETSEL       =8
%SS_SELMODE_GETSELITEM   =9

'// Button styles used by SSSetTypeButton
%BS_CENTER             = &H00000300&

'// Button styles used by SSSetTypeButton
%SBS_DEFPUSHBUTTON        = &H0001&
%SBS_TEXTTOP_PICTBOT      = &H0002&
%SBS_TEXTBOT_PICTTOP      = &H0004&
%SBS_TEXTLEFT_PICTRIGHT   = &H0008&
%SBS_TEXTRIGHT_PICTLEFT   = &H0010&
%SBS_BTNFRAMEIN           = &H0020&
%SBS_BTNFRAMEOUT          = &H0040&
%SBS_PICTFRAMEIN          = &H0080&
%SBS_PICTFRAMEOUT         = &H0100&
%SBS_TEXTFRAMEIN          = &H0200&
%SBS_TEXTFRAMEOUT         = &H0400&
%SBS_NOINVERTFRAME        = &H0800&
%SBS_TEXTICON             = &H1000&
%SBS_TEXTBITMAP           = &H2000&
%SBS_TEXTTEXT             = &H4000&
%SBS_NOPOINTERFOCUS       = &H8000&

%SUPERBTN_UP             = 0
%SUPERBTN_DOWN           = 1

'// Button types used by SSSetTypeButton
%SUPERBTN_TYPE_NORMAL    = 0
%SUPERBTN_TYPE_2STATE    = 1


'// Check box picture types used by SSSetTypeCheckBox
%BT_NONE                  = &H0000
%BT_ICON                  = &H0001
%BT_BITMAP                = &H0002
%BT_HANDLE                = &H0004
%BT_PICT_UP               = &H0010
%BT_PICT_DOWN             = &H0020
%BT_PICT_FOCUSUP          = &H0040
%BT_PICT_FOCUSDOWN        = &H0080
%BT_PICT_DISABLEDUP       = &H0100
%BT_PICT_DISABLEDDOWN     = &H0200
%BT_PICT_GRAY             = &H0400
%BT_PICT_FOCUSGRAY        = &H0800
%BT_PICT_DISABLEDGRAY     = &H1000

'// Button picture types used by SSSetTypeButton
%SUPERBTN_PICT_NONE      = 0
%SUPERBTN_PICT_ICON      = %BT_ICON
%SUPERBTN_PICT_BITMAP    = %BT_BITMAP
%SUPERBTN_PICT_HANDLE    = %BT_HANDLE


'// Combo box style used by SSSetTypeComboBox
%SS_CB_DROPDOWN         = &H02

'// Combo box cell messages used by SSComboBoxSendMessage
%SS_CBM_ADDSTRING       =%CB_ADDSTRING
%SS_CBM_DELETESTRING    =%CB_DELETESTRING
%SS_CBM_GETCOUNT        =%CB_GETCOUNT
%SS_CBM_GETCURSEL       =%CB_GETCURSEL
%SS_CBM_GETLBTEXT       =%CB_GETLBTEXT
%SS_CBM_GETLBTEXTLEN    =%CB_GETLBTEXTLEN
%SS_CBM_INSERTSTRING    =%CB_INSERTSTRING
%SS_CBM_RESETCONTENT    =%CB_RESETCONTENT
%SS_CBM_SETCURSEL       =%CB_SETCURSEL

'// Date styles used by SSSetTypeDate
%DS_SPIN        = &H0040&
%DS_DEFCENTURY  = &H0004&
%DS_CENTURY     = &H1000&
%DS_DDMONYY     = &H2000&
%DS_DDMMYY      = &H4000&
%DS_MMDDYY      = &H6000&
%DS_YYMMDD      = &H8000&

'// Edit styles used by SSSetTypeEdit
%ES_STATIC      = &H0080&
%ES_OVERSTRIKE  = &H0800&
%ES_LEFTALIGN   = &H0200&
%ES_3D          = &H0400&
#IF NOT %DEF(%ES_UPPERCASE)
  %ES_UPPERCASE   = &H0008&
#ENDIF
#IF NOT %DEF(%ES_LOWERCASE)
  %ES_LOWERCASE   = &H0010&
#ENDIF

'// Character sets used by SSSetTypeEdit
%SS_CHRSET_CHR           = 0
%SS_CHRSET_ALPHA         = 1
%SS_CHRSET_ALPHANUM      = 2
%SS_CHRSET_NUM           = 3
'//- Character sets supported in the JPN version. (Masanori Iwasa)
%SS_CHRSET_KNJONLY       = 4
%SS_CHRSET_KNJONLY_IME   = 5
%SS_CHRSET_ALLCHR_IME    = 6

'// Character cases used by SSSetTypeEdit
%SS_CASE_LCASE         = 0
%SS_CASE_NOCASE        = 1
%SS_CASE_UCASE         = 2

'// Float styles used by SSSetTypeFloat
%FS_MONEY       = &H1000&
%FS_SEPARATOR   = &H2000&

'// Integer styles used by SSSetTypeInteger
%IS_SPIN        = &H1000&
%IS_SPINWRAP    = &H2000&

'// Picture styles used by SSSetTypePicture
%VPS_NORMAL            = &H0000&
%VPS_CENTER            = &H0001&
%VPS_STRETCH           = &H0002&
%VPS_MAINTAINSCALE     = &H0004&
%VPS_SCROLL            = &H0008&
%VPS_RESOURCE          = &H0010&
%VPS_BMP               = &H0020&
%VPS_PCX               = &H0040&
%VPS_GIF               = &H0080&
%VPS_FREEZE            = &H0100&
%VPS_SHOWFRAMEONCE     = &H0200&
%VPS_STATIC            = &H0400&
%VPS_HANDLE            = &H0800&
%VPS_ICON              = &H1000&
%VPS_METAFILE          = &H2000&

'// Text styles used by SSSetTypeStatic
%SS_TEXT_LEFT           = &H001
%SS_TEXT_RIGHT          = &H002
%SS_TEXT_CENTER         = &H004
%SS_TEXT_VCENTER        = &H008
%SS_TEXT_TOP            = &H010
%SS_TEXT_BOTTOM         = &H020
%SS_TEXT_WORDWRAP       = &H040
%SS_TEXT_SHADOW         = &H080
%SS_TEXT_PREFIX         = &H100
%SS_TEXT_SHADOWIN       = &H200

'// Time styles used by SSSetTypeTime
%TS_12HOUR      = &H1000&
%TS_24HOUR      = &H2000&
%TS_SECONDS     = &H4000&
%TS_SPIN        = &H8000&

'// Alignment styles for creating cell types
%SSS_ALIGN_TOP     = &H00010000&
%SSS_ALIGN_VCENTER = &H00020000&
%SSS_ALIGN_BOTTOM  = &H00040000&
%SSS_ALIGN_LEFT    = &H00100000&
%SSS_ALIGN_CENTER  = &H00200000&
%SSS_ALIGN_RIGHT   = &H00400000&

'// Positions used by SSShowActiveCell and SSShowCell
%SS_SHOW_TOPLEFT       = 0
%SS_SHOW_TOPCENTER     = 1
%SS_SHOW_TOPRIGHT      = 2
%SS_SHOW_CENTERLEFT    = 3
%SS_SHOW_CENTER        = 4
%SS_SHOW_CENTERRIGHT   = 5
%SS_SHOW_BOTTOMLEFT    = 6
%SS_SHOW_BOTTOMCENTER  = 7
%SS_SHOW_BOTTOMRIGHT   = 8
%SS_SHOW_NEAREST       = 9

'// Unit types used by SSSetUnitType
%SS_UNITTYPE_NORMAL    = 0
%SS_UNITTYPE_DEFAULT   = 1
%SS_UNITTYPE_TWIPS     = 2

'// User resize options used by SSSetUserResize
%SS_USERRESIZE_COL      = &H01
%SS_USERRESIZE_ROW      = &H02

'// User resize options used by SSSetUserResizeCol and SSSetUserResizeRow
%SS_RESIZE_DEFAULT     = 0
%SS_RESIZE_ON          = 1
%SS_RESIZE_OFF         = 2

'// Used by SSGetVisible
%SS_VISIBLE_PARTIAL    = 0
%SS_VISIBLE_ALL        = 1

'// Virtual mode styles used by SSVSetStyle
%SSV_SCROLLBARSHOWBUFFER = &H01
%SSV_NOROWNUMBERS        = &H02

'// Virtual scroll bar options used by SSVScrollSetSpecial
%SS_VSCROLL_NOHOMEEND  = &H01
%SS_VSCROLL_NOPAGEUPDN = &H02
%SS_VSCROLL_NOUPDN     = &H04

'// Appearance property settings
%SS_APPEARANCE_FLAT         = 0
%SS_APPEARANCE_3D           = 1
%SS_APPEARANCE_3DWITHBORDER = 2
%SS_APPEARANCE_DEFAULT      = 3

'// ClipboardOptions
%SS_CLIP_NOHEADERS           = 0
%SS_CLIP_COPYROWHEADERS      = 1
%SS_CLIP_PASTEROWHEADERS     = 2
%SS_CLIP_COPYCOLHEADERS      = 4
%SS_CLIP_PASTECOLHEADERS     = 8
%SS_CLIP_COPYPASTEALLHEADERS = 15

'// Combo Width
%SS_COMBOWIDTH_CELLWIDTH    = 0
%SS_COMBOWIDTH_AUTORIGHT    = 1
%SS_COMBOWIDTH_AUTOLEFT     = -1


'// Keyboard actions
%SS_KBA_CURRENT =0
%SS_KBA_POPUP   =1
%SS_KBA_CLEAR   =2
%SS_KBA_CNT    = 3

'// Keyboard Key Constants
%SS_KBK_F2	= 0
%SS_KBK_F3	= 2
%SS_KBK_F4 	= 3
'preview Not yet Done

'//--------------------------------------------------------------------
'// Preview Control
'//--------------------------------------------------------------------

'#define SPVN_PAGECHANGE             1
'#define SPVN_ZOOM                   2

'#define SPV_MARGINTYPE_SCALED       0
'#define SPV_MARGINTYPE_ACTUAL       1

'#define SPV_VIEWTYPE_WHOLEPAGE      0
'#define SPV_VIEWTYPE_NORMALSIZE     1
'#define SPV_VIEWTYPE_PERCENTAGE     2
'#define SPV_VIEWTYPE_PAGEWIDTH      3
'#define SPV_VIEWTYPE_PAGEHEIGHT     4
'#define SPV_VIEWTYPE_MULTIPLEPAGES  5

'#define SPV_ZOOMSTATE_INDETERMINATE 0
'#define SPV_ZOOMSTATE_IN            1
'#define SPV_ZOOMSTATE_OUT           2
'#define SPV_ZOOMSTATE_SWITCH        3

'#define SPV_SCROLLBAR_SHOW          0
'#define SPV_SCROLLBAR_AUTO          1
'#define SPV_SCROLLBAR_HIDE          2

'#ifndef FP_API
'#ifdef  WIN32
'#define FP_API   __declspec(dllexport) __stdcall
'#else
'#define FP_API   FAR PASCAL _export
'#endif
'#endif

'int FP_API SpvGetAllowUserZoom(HWND hWnd, BOOL FAR *lpValue);
'int FP_API SpvGetGrayAreaColor(HWND hWnd, COLORREF FAR *lpValue);
'int FP_API SpvGetGrayAreaMarginH(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetGrayAreaMarginType(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetGrayAreaMarginV(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetPageBorderColor(HWND hWnd, COLORREF FAR *lpValue);
'int FP_API SpvGetPageBorderWidth(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPageCurrent(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetPageGutterH(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetPageGutterV(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetPageMultiCntH(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPageMultiCntV(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPagePercentageActual(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPageShadowColor(HWND hWnd, COLORREF FAR *lpValue);
'int FP_API SpvGetPageShadowWidth(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPageViewPercentage(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPageViewType(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetPagesPerScreen(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetScrollBarH(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetScrollBarV(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGetScrollIncH(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetScrollIncV(HWND hWnd, long FAR *lpValue);
'int FP_API SpvGetZoomState(HWND hWnd, short FAR *lpValue);
'int FP_API SpvGethWndSpread(HWND hPreview, HWND FAR *lphSpread);
'int FP_API SpvSetAllowUserZoom(HWND hWnd, BOOL value);
'int FP_API SpvSetGrayAreaColor(HWND hWnd, COLORREF value);
'int FP_API SpvSetGrayAreaMarginH(HWND hWnd, long value);
'int FP_API SpvSetGrayAreaMarginType(HWND hWnd, short value);
'int FP_API SpvSetGrayAreaMarginV(HWND hWnd, long value);
'int FP_API SpvSetPageBorderColor(HWND hWnd, COLORREF value);
'int FP_API SpvSetPageBorderWidth(HWND hWnd, short value);
'int FP_API SpvSetPageCurrent(HWND hWnd, long value);
'int FP_API SpvSetPageGutterH(HWND hWnd, long value);
'int FP_API SpvSetPageGutterV(HWND hWnd, long value);
'int FP_API SpvSetPageMultiCntH(HWND hWnd, short value);
'int FP_API SpvSetPageMultiCntV(HWND hWnd, short value);
'int FP_API SpvSetPageShadowColor(HWND hWnd, COLORREF value);
'int FP_API SpvSetPageShadowWidth(HWND hWnd, short value);
'int FP_API SpvSetPageViewPercentage(HWND hWnd, short value);
'int FP_API SpvSetPageViewType(HWND hWnd, short value);
'int FP_API SpvSetScrollBarH(HWND hWnd, short value);
'int FP_API SpvSetScrollBarV(HWND hWnd, short value);
'int FP_API SpvSetScrollIncH(HWND hWnd, long value);
'int FP_API SpvSetScrollIncV(HWND hWnd, long value);
'int FP_API SpvSetZoomState(HWND hWnd, short value);
'int FP_API SpvSethWndSpread(HWND hPreview, HWND hSpread);

'//--------------------------------------------------------------------


'//--------------------------------------------------------------------

'#ifndef RC_INVOKED
'#pragma pack()
'#endif  /* RC_INVOKED */
'
'#ifdef __cplusplus
'}
'#endif

'#endif
'$ENDIF
#IF 0
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=
'UDT for user data
'===========================================================================
TYPE SS_USERDATA
  GridError         AS LONG
  DataChanged   AS LONG
  psCurrentFile     AS STRING PTR
  PrintFormat   AS ss_printformat
  hHeaderFont   AS DWORD
  pszHeader         AS ASCIIZ PTR
  pszFormatFile     AS ASCIIZ PTR
  BlockSelected     AS LONG
  ColRecord         AS LONG
  Reserved1         AS LONG
  Reserved2         AS LONG
END TYPE
'---------------------------------------------------------------------------
'~SS_UserDataFreeMem
'---------------------------------------------------------------------------
' Free Memory allocated for SS_USERDATA structure
'---------------------------------------------------------------------------
FUNCTION _
  SS_UserDataFreeMem ( _
    BYVAL hWnd      AS DWORD,_
    BYVAL lParam    AS LONG _
  )AS LONG

  DIM szClassName   AS ASCIIZ * 256, _
      RetVal        AS DWORD

  GetClassName hWnd,szClassName,SIZEOF(szClassName)

  IF szClassName = $SS_CLASSNAME THEN
    RetVal = SSGetUserData(hWnd)
    'MsgBox $SS_CLASSNAME +CHR$(13,10) + "RetVal = " +FORMAT$(RetVal)
    IF RetVal THEN
      GlobalFree RetVal
    END IF
  END IF

  FUNCTION = 1
END FUNCTION
'===========================================================================
'~GridData2Array
'===========================================================================
' Converts a tab crlf delimited string to a string array
' DataArray(col,row)
'===========================================================================
FUNCTION _
  GridData2Array ( _
    BYVAL sGridData         AS STRING, _
          DataArray()   AS STRING _
  )AS LONG

  DIM sRows(1)      AS STRING, _
      sCols(1)      AS STRING, _
      Rows          AS LONG, _
      Cols          AS LONG, _
      S1            AS STRING, _
      x                 AS LONG, _
      y                 AS LONG, _
      z                 AS LONG


  REPLACE $CRLF WITH CHR$(255) IN sGridData

  Rows = ParseOne(sGridData, CHR$(255), sRows())
  Cols = TALLY(sRows(1), $TAB)+1
  REDIM DataArray(1 TO Cols,1 TO Rows)
  FOR x = 1 TO Rows
    z = ParseOne(sRows(x), $TAB, sCols())
    FOR y = 1 TO z
      IF y > Cols THEN
        EXIT FOR
      END IF
      DataArray(y,x) = sCols(y)
    NEXT y
  NEXT x

  FUNCTION = MAKLNG(Cols,Rows)
END FUNCTION
#ENDIF